// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles

(function(modules, entry, mainEntry, parcelRequireName, globalName) {
  /* eslint-disable no-undef */
  var globalObject =
    typeof globalThis !== 'undefined'
      ? globalThis
      : typeof self !== 'undefined'
      ? self
      : typeof window !== 'undefined'
      ? window
      : typeof global !== 'undefined'
      ? global
      : {};
  /* eslint-enable no-undef */

  // Save the require from previous bundle to this closure if any
  var previousRequire =
    typeof globalObject[parcelRequireName] === 'function' &&
    globalObject[parcelRequireName];

  var cache = previousRequire.cache || {};
  // Do not use `require` to prevent Webpack from trying to bundle this call
  var nodeRequire =
    typeof module !== 'undefined' &&
    typeof module.require === 'function' &&
    module.require.bind(module);

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire =
          typeof globalObject[parcelRequireName] === 'function' &&
          globalObject[parcelRequireName];
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error("Cannot find module '" + name + "'");
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = (cache[name] = new newRequire.Module(name));

      modules[name][0].call(
        module.exports,
        localRequire,
        module,
        module.exports,
        this
      );
    }

    return cache[name].exports;

    function localRequire(x) {
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x) {
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function(id, exports) {
    modules[id] = [
      function(require, module) {
        module.exports = exports;
      },
      {},
    ];
  };

  Object.defineProperty(newRequire, 'root', {
    get: function() {
      return globalObject[parcelRequireName];
    },
  });

  globalObject[parcelRequireName] = newRequire;

  for (var i = 0; i < entry.length; i++) {
    newRequire(entry[i]);
  }

  if (mainEntry) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(mainEntry);

    // CommonJS
    if (typeof exports === 'object' && typeof module !== 'undefined') {
      module.exports = mainExports;

      // RequireJS
    } else if (typeof define === 'function' && define.amd) {
      define(function() {
        return mainExports;
      });

      // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }
})({"1nxmM":[function(require,module,exports) {
var HMR_HOST = null;
var HMR_PORT = null;
var HMR_SECURE = false;
var HMR_ENV_HASH = "4e5dac8afe405db7";
module.bundle.HMR_BUNDLE_ID = "9faf444bc71f97c6";
"use strict";
function _createForOfIteratorHelper(o, allowArrayLike) {
    var it;
    if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
        if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
            if (it) o = it;
            var i = 0;
            var F = function F1() {
            };
            return {
                s: F,
                n: function n() {
                    if (i >= o.length) return {
                        done: true
                    };
                    return {
                        done: false,
                        value: o[i++]
                    };
                },
                e: function e(_e) {
                    throw _e;
                },
                f: F
            };
        }
        throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var normalCompletion = true, didErr = false, err;
    return {
        s: function s() {
            it = o[Symbol.iterator]();
        },
        n: function n() {
            var step = it.next();
            normalCompletion = step.done;
            return step;
        },
        e: function e(_e2) {
            didErr = true;
            err = _e2;
        },
        f: function f() {
            try {
                if (!normalCompletion && it.return != null) it.return();
            } finally{
                if (didErr) throw err;
            }
        }
    };
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
/* global HMR_HOST, HMR_PORT, HMR_ENV_HASH, HMR_SECURE */ /*::
import type {
  HMRAsset,
  HMRMessage,
} from '@parcel/reporter-dev-server/src/HMRServer.js';
interface ParcelRequire {
  (string): mixed;
  cache: {|[string]: ParcelModule|};
  hotData: mixed;
  Module: any;
  parent: ?ParcelRequire;
  isParcelRequire: true;
  modules: {|[string]: [Function, {|[string]: string|}]|};
  HMR_BUNDLE_ID: string;
  root: ParcelRequire;
}
interface ParcelModule {
  hot: {|
    data: mixed,
    accept(cb: (Function) => void): void,
    dispose(cb: (mixed) => void): void,
    // accept(deps: Array<string> | string, cb: (Function) => void): void,
    // decline(): void,
    _acceptCallbacks: Array<(Function) => void>,
    _disposeCallbacks: Array<(mixed) => void>,
  |};
}
declare var module: {bundle: ParcelRequire, ...};
declare var HMR_HOST: string;
declare var HMR_PORT: string;
declare var HMR_ENV_HASH: string;
declare var HMR_SECURE: boolean;
*/ var OVERLAY_ID = '__parcel__error__overlay__';
var OldModule = module.bundle.Module;
function Module(moduleName) {
    OldModule.call(this, moduleName);
    this.hot = {
        data: module.bundle.hotData,
        _acceptCallbacks: [],
        _disposeCallbacks: [],
        accept: function accept(fn) {
            this._acceptCallbacks.push(fn || function() {
            });
        },
        dispose: function dispose(fn) {
            this._disposeCallbacks.push(fn);
        }
    };
    module.bundle.hotData = undefined;
}
module.bundle.Module = Module;
var checkedAssets, acceptedAssets, assetsToAccept;
function getHostname() {
    return HMR_HOST || (location.protocol.indexOf('http') === 0 ? location.hostname : 'localhost');
}
function getPort() {
    return HMR_PORT || location.port;
} // eslint-disable-next-line no-redeclare
var parent = module.bundle.parent;
if ((!parent || !parent.isParcelRequire) && typeof WebSocket !== 'undefined') {
    var hostname = getHostname();
    var port = getPort();
    var protocol = HMR_SECURE || location.protocol == 'https:' && !/localhost|127.0.0.1|0.0.0.0/.test(hostname) ? 'wss' : 'ws';
    var ws = new WebSocket(protocol + '://' + hostname + (port ? ':' + port : '') + '/'); // $FlowFixMe
    ws.onmessage = function(event) {
        checkedAssets = {
        };
        acceptedAssets = {
        };
        assetsToAccept = [];
        var data = JSON.parse(event.data);
        if (data.type === 'update') {
            // Remove error overlay if there is one
            removeErrorOverlay();
            var assets = data.assets.filter(function(asset) {
                return asset.envHash === HMR_ENV_HASH;
            }); // Handle HMR Update
            var handled = assets.every(function(asset) {
                return asset.type === 'css' || asset.type === 'js' && hmrAcceptCheck(module.bundle.root, asset.id, asset.depsByBundle);
            });
            if (handled) {
                console.clear();
                assets.forEach(function(asset) {
                    hmrApply(module.bundle.root, asset);
                });
                for(var i = 0; i < assetsToAccept.length; i++){
                    var id = assetsToAccept[i][1];
                    if (!acceptedAssets[id]) hmrAcceptRun(assetsToAccept[i][0], id);
                }
            } else window.location.reload();
        }
        if (data.type === 'error') {
            // Log parcel errors to console
            var _iterator = _createForOfIteratorHelper(data.diagnostics.ansi), _step;
            try {
                for(_iterator.s(); !(_step = _iterator.n()).done;){
                    var ansiDiagnostic = _step.value;
                    var stack = ansiDiagnostic.codeframe ? ansiDiagnostic.codeframe : ansiDiagnostic.stack;
                    console.error('🚨 [parcel]: ' + ansiDiagnostic.message + '\n' + stack + '\n\n' + ansiDiagnostic.hints.join('\n'));
                } // Render the fancy html overlay
            } catch (err) {
                _iterator.e(err);
            } finally{
                _iterator.f();
            }
            removeErrorOverlay();
            var overlay = createErrorOverlay(data.diagnostics.html); // $FlowFixMe
            document.body.appendChild(overlay);
        }
    };
    ws.onerror = function(e) {
        console.error(e.message);
    };
    ws.onclose = function() {
        console.warn('[parcel] 🚨 Connection to the HMR server was lost');
    };
}
function removeErrorOverlay() {
    var overlay = document.getElementById(OVERLAY_ID);
    if (overlay) {
        overlay.remove();
        console.log('[parcel] ✨ Error resolved');
    }
}
function createErrorOverlay(diagnostics) {
    var overlay = document.createElement('div');
    overlay.id = OVERLAY_ID;
    var errorHTML = '<div style="background: black; opacity: 0.85; font-size: 16px; color: white; position: fixed; height: 100%; width: 100%; top: 0px; left: 0px; padding: 30px; font-family: Menlo, Consolas, monospace; z-index: 9999;">';
    var _iterator2 = _createForOfIteratorHelper(diagnostics), _step2;
    try {
        for(_iterator2.s(); !(_step2 = _iterator2.n()).done;){
            var diagnostic = _step2.value;
            var stack = diagnostic.codeframe ? diagnostic.codeframe : diagnostic.stack;
            errorHTML += "\n      <div>\n        <div style=\"font-size: 18px; font-weight: bold; margin-top: 20px;\">\n          \uD83D\uDEA8 ".concat(diagnostic.message, "\n        </div>\n        <pre>\n          ").concat(stack, "\n        </pre>\n        <div>\n          ").concat(diagnostic.hints.map(function(hint) {
                return '<div>' + hint + '</div>';
            }).join(''), "\n        </div>\n      </div>\n    ");
        }
    } catch (err) {
        _iterator2.e(err);
    } finally{
        _iterator2.f();
    }
    errorHTML += '</div>';
    overlay.innerHTML = errorHTML;
    return overlay;
}
function getParents(bundle, id) /*: Array<[ParcelRequire, string]> */ {
    var modules = bundle.modules;
    if (!modules) return [];
    var parents = [];
    var k, d, dep;
    for(k in modules)for(d in modules[k][1]){
        dep = modules[k][1][d];
        if (dep === id || Array.isArray(dep) && dep[dep.length - 1] === id) parents.push([
            bundle,
            k
        ]);
    }
    if (bundle.parent) parents = parents.concat(getParents(bundle.parent, id));
    return parents;
}
function updateLink(link) {
    var newLink = link.cloneNode();
    newLink.onload = function() {
        if (link.parentNode !== null) // $FlowFixMe
        link.parentNode.removeChild(link);
    };
    newLink.setAttribute('href', link.getAttribute('href').split('?')[0] + '?' + Date.now()); // $FlowFixMe
    link.parentNode.insertBefore(newLink, link.nextSibling);
}
var cssTimeout = null;
function reloadCSS() {
    if (cssTimeout) return;
    cssTimeout = setTimeout(function() {
        var links = document.querySelectorAll('link[rel="stylesheet"]');
        for(var i = 0; i < links.length; i++){
            // $FlowFixMe[incompatible-type]
            var href = links[i].getAttribute('href');
            var hostname = getHostname();
            var servedFromHMRServer = hostname === 'localhost' ? new RegExp('^(https?:\\/\\/(0.0.0.0|127.0.0.1)|localhost):' + getPort()).test(href) : href.indexOf(hostname + ':' + getPort());
            var absolute = /^https?:\/\//i.test(href) && href.indexOf(window.location.origin) !== 0 && !servedFromHMRServer;
            if (!absolute) updateLink(links[i]);
        }
        cssTimeout = null;
    }, 50);
}
function hmrApply(bundle, asset) {
    var modules = bundle.modules;
    if (!modules) return;
    if (asset.type === 'css') {
        reloadCSS();
        return;
    }
    var deps = asset.depsByBundle[bundle.HMR_BUNDLE_ID];
    if (deps) {
        var fn = new Function('require', 'module', 'exports', asset.output);
        modules[asset.id] = [
            fn,
            deps
        ];
    } else if (bundle.parent) hmrApply(bundle.parent, asset);
}
function hmrAcceptCheck(bundle, id, depsByBundle) {
    var modules = bundle.modules;
    if (!modules) return;
    if (depsByBundle && !depsByBundle[bundle.HMR_BUNDLE_ID]) {
        // If we reached the root bundle without finding where the asset should go,
        // there's nothing to do. Mark as "accepted" so we don't reload the page.
        if (!bundle.parent) return true;
        return hmrAcceptCheck(bundle.parent, id, depsByBundle);
    }
    if (checkedAssets[id]) return;
    checkedAssets[id] = true;
    var cached = bundle.cache[id];
    assetsToAccept.push([
        bundle,
        id
    ]);
    if (cached && cached.hot && cached.hot._acceptCallbacks.length) return true;
    return getParents(module.bundle.root, id).some(function(v) {
        return hmrAcceptCheck(v[0], v[1], null);
    });
}
function hmrAcceptRun(bundle, id) {
    var cached = bundle.cache[id];
    bundle.hotData = {
    };
    if (cached && cached.hot) cached.hot.data = bundle.hotData;
    if (cached && cached.hot && cached.hot._disposeCallbacks.length) cached.hot._disposeCallbacks.forEach(function(cb) {
        cb(bundle.hotData);
    });
    delete bundle.cache[id];
    bundle(id);
    cached = bundle.cache[id];
    if (cached && cached.hot && cached.hot._acceptCallbacks.length) cached.hot._acceptCallbacks.forEach(function(cb) {
        var assetsToAlsoAccept = cb(function() {
            return getParents(module.bundle.root, id);
        });
        if (assetsToAlsoAccept && assetsToAccept.length) // $FlowFixMe[method-unbinding]
        assetsToAccept.push.apply(assetsToAccept, assetsToAlsoAccept);
    });
    acceptedAssets[id] = true;
}

},{}]},["1nxmM"], null, "parcelRequire46a6")
// Generated by purs bundle 0.14.3
var PS = {
};
(function(exports) {
    exports._ajax = (function() {
        var platformSpecific = {
        };
        if (typeof module !== "undefined" && module.require && !(typeof process !== "undefined" && process.versions["electron"])) {
            // We are on node.js
            platformSpecific.newXHR = function() {
                var XHR = module.require("xhr2");
                return new XHR();
            };
            platformSpecific.fixupUrl = function(url, xhr) {
                if (xhr.nodejsBaseUrl === null) {
                    var urllib = module.require("url");
                    var u = urllib.parse(url);
                    u.protocol = u.protocol || "http:";
                    u.hostname = u.hostname || "localhost";
                    return urllib.format(u);
                } else return url || "/";
            };
            platformSpecific.getResponse = function(xhr) {
                return xhr.response;
            };
        } else {
            // We are in the browser
            platformSpecific.newXHR = function() {
                return new XMLHttpRequest();
            };
            platformSpecific.fixupUrl = function(url) {
                return url || "/";
            };
            platformSpecific.getResponse = function(xhr) {
                return xhr.response;
            };
        }
        return function(timeoutErrorMessageIdent, requestFailedMessageIdent, mkHeader, options) {
            return function(errback, callback) {
                var xhr = platformSpecific.newXHR();
                var fixedUrl = platformSpecific.fixupUrl(options.url, xhr);
                xhr.open(options.method || "GET", fixedUrl, true, options.username, options.password);
                if (options.headers) try {
                    // eslint-disable-next-line no-eq-null,eqeqeq
                    for(var i = 0, header; (header = options.headers[i]) != null; i++)xhr.setRequestHeader(header.field, header.value);
                } catch (e) {
                    errback(e);
                }
                var onerror = function(msgIdent) {
                    return function() {
                        errback(new Error(msgIdent));
                    };
                };
                xhr.onerror = onerror(requestFailedMessageIdent);
                xhr.ontimeout = onerror(timeoutErrorMessageIdent);
                xhr.onload = function() {
                    callback({
                        status: xhr.status,
                        statusText: xhr.statusText,
                        headers: xhr.getAllResponseHeaders().split("\r\n").filter(function(header1) {
                            return header1.length > 0;
                        }).map(function(header1) {
                            var i1 = header1.indexOf(":");
                            return mkHeader(header1.substring(0, i1))(header1.substring(i1 + 2));
                        }),
                        body: platformSpecific.getResponse(xhr)
                    });
                };
                xhr.responseType = options.responseType;
                xhr.withCredentials = options.withCredentials;
                xhr.timeout = options.timeout;
                xhr.send(options.content);
                return function(error, cancelErrback, cancelCallback) {
                    try {
                        xhr.abort();
                    } catch (e) {
                        return cancelErrback(e);
                    }
                    return cancelCallback();
                };
            };
        };
    })();
})(PS["Affjax"] = PS["Affjax"] || {
});
(function($PS) {
    $PS["Control.Apply"] = $PS["Control.Apply"] || {
    };
    var exports = $PS["Control.Apply"];
    var Apply = function(Functor0, apply) {
        this.Functor0 = Functor0;
        this.apply = apply;
    };
    var apply = function(dict) {
        return dict.apply;
    };
    exports["Apply"] = Apply;
    exports["apply"] = apply;
})(PS);
(function($PS) {
    $PS["Control.Applicative"] = $PS["Control.Applicative"] || {
    };
    var exports = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Applicative = function(Apply0, pure) {
        this.Apply0 = Apply0;
        this.pure = pure;
    };
    var pure = function(dict) {
        return dict.pure;
    };
    var liftA1 = function(dictApplicative) {
        return function(f) {
            return function(a) {
                return Control_Apply.apply(dictApplicative.Apply0())(pure(dictApplicative)(f))(a);
            };
        };
    };
    exports["Applicative"] = Applicative;
    exports["pure"] = pure;
    exports["liftA1"] = liftA1;
})(PS);
(function($PS) {
    $PS["Data.Function"] = $PS["Data.Function"] || {
    };
    var exports = $PS["Data.Function"];
    var on = function(f) {
        return function(g) {
            return function(x) {
                return function(y) {
                    return f(g(x))(g(y));
                };
            };
        };
    };
    var flip = function(f) {
        return function(b) {
            return function(a) {
                return f(a)(b);
            };
        };
    };
    var $$const = function(a) {
        return function(v) {
            return a;
        };
    };
    exports["flip"] = flip;
    exports["const"] = $$const;
    exports["on"] = on;
})(PS);
(function($PS) {
    $PS["Control.Bind"] = $PS["Control.Bind"] || {
    };
    var exports = $PS["Control.Bind"];
    var Data_Function = $PS["Data.Function"];
    var Bind = function(Apply0, bind) {
        this.Apply0 = Apply0;
        this.bind = bind;
    };
    var Discard = function(discard) {
        this.discard = discard;
    };
    var discard = function(dict) {
        return dict.discard;
    };
    var bind = function(dict) {
        return dict.bind;
    };
    var bindFlipped = function(dictBind) {
        return Data_Function.flip(bind(dictBind));
    };
    var composeKleisliFlipped = function(dictBind) {
        return function(f) {
            return function(g) {
                return function(a) {
                    return bindFlipped(dictBind)(f)(g(a));
                };
            };
        };
    };
    var discardUnit = new Discard(function(dictBind) {
        return bind(dictBind);
    });
    exports["Bind"] = Bind;
    exports["bind"] = bind;
    exports["bindFlipped"] = bindFlipped;
    exports["discard"] = discard;
    exports["composeKleisliFlipped"] = composeKleisliFlipped;
    exports["discardUnit"] = discardUnit;
})(PS);
(function($PS) {
    $PS["Control.Semigroupoid"] = $PS["Control.Semigroupoid"] || {
    };
    var exports = $PS["Control.Semigroupoid"];
    var Semigroupoid = function(compose) {
        this.compose = compose;
    };
    var semigroupoidFn = new Semigroupoid(function(f) {
        return function(g) {
            return function(x) {
                return f(g(x));
            };
        };
    });
    var compose = function(dict) {
        return dict.compose;
    };
    exports["compose"] = compose;
    exports["semigroupoidFn"] = semigroupoidFn;
})(PS);
(function($PS) {
    $PS["Control.Category"] = $PS["Control.Category"] || {
    };
    var exports = $PS["Control.Category"];
    var Control_Semigroupoid = $PS["Control.Semigroupoid"];
    var Category = function(Semigroupoid0, identity) {
        this.Semigroupoid0 = Semigroupoid0;
        this.identity = identity;
    };
    var identity = function(dict) {
        return dict.identity;
    };
    var categoryFn = new Category(function() {
        return Control_Semigroupoid.semigroupoidFn;
    }, function(x) {
        return x;
    });
    exports["identity"] = identity;
    exports["categoryFn"] = categoryFn;
})(PS);
(function(exports) {
    exports.arrayMap = function(f) {
        return function(arr) {
            var l = arr.length;
            var result = new Array(l);
            for(var i = 0; i < l; i++)result[i] = f(arr[i]);
            return result;
        };
    };
})(PS["Data.Functor"] = PS["Data.Functor"] || {
});
(function(exports) {
    exports.unit = {
    };
})(PS["Data.Unit"] = PS["Data.Unit"] || {
});
(function($PS) {
    $PS["Data.Unit"] = $PS["Data.Unit"] || {
    };
    var exports = $PS["Data.Unit"];
    var $foreign = $PS["Data.Unit"];
    exports["unit"] = $foreign.unit;
})(PS);
(function($PS) {
    $PS["Data.Functor"] = $PS["Data.Functor"] || {
    };
    var exports = $PS["Data.Functor"];
    var $foreign = $PS["Data.Functor"];
    var Data_Function = $PS["Data.Function"];
    var Data_Unit = $PS["Data.Unit"];
    var Functor = function(map) {
        this.map = map;
    };
    var map = function(dict) {
        return dict.map;
    };
    var mapFlipped = function(dictFunctor) {
        return function(fa) {
            return function(f) {
                return map(dictFunctor)(f)(fa);
            };
        };
    };
    var $$void = function(dictFunctor) {
        return map(dictFunctor)(Data_Function["const"](Data_Unit.unit));
    };
    var functorArray = new Functor($foreign.arrayMap);
    exports["Functor"] = Functor;
    exports["map"] = map;
    exports["mapFlipped"] = mapFlipped;
    exports["void"] = $$void;
    exports["functorArray"] = functorArray;
})(PS);
(function(exports) {
    exports.showIntImpl = function(n) {
        return n.toString();
    };
    exports.showStringImpl = function(s) {
        var l = s.length;
        return "\"" + s.replace(/[\0-\x1F\x7F"\\]/g, function(c, i) {
            switch(c){
                case "\"":
                case "\\":
                    return "\\" + c;
                case "\x07":
                    return "\\a";
                case "\b":
                    return "\\b";
                case "\f":
                    return "\\f";
                case "\n":
                    return "\\n";
                case "\r":
                    return "\\r";
                case "\t":
                    return "\\t";
                case "\v":
                    return "\\v";
            }
            var k = i + 1;
            var empty = k < l && s[k] >= "0" && s[k] <= "9" ? "\\&" : "";
            return "\\" + c.charCodeAt(0).toString(10) + empty;
        }) + "\"";
    };
    exports.showArrayImpl = function(f) {
        return function(xs) {
            var ss = [];
            for(var i = 0, l = xs.length; i < l; i++)ss[i] = f(xs[i]);
            return "[" + ss.join(",") + "]";
        };
    };
    exports.cons = function(head) {
        return function(tail) {
            return [
                head
            ].concat(tail);
        };
    };
    exports.join = function(separator) {
        return function(xs) {
            return xs.join(separator);
        };
    };
})(PS["Data.Show"] = PS["Data.Show"] || {
});
(function($PS) {
    $PS["Data.Symbol"] = $PS["Data.Symbol"] || {
    };
    var exports = $PS["Data.Symbol"];
    var SProxy = function() {
        function SProxy1() {
        }
        SProxy1.value = new SProxy1();
        return SProxy1;
    }();
    var IsSymbol = function(reflectSymbol) {
        this.reflectSymbol = reflectSymbol;
    };
    var reflectSymbol = function(dict) {
        return dict.reflectSymbol;
    };
    exports["IsSymbol"] = IsSymbol;
    exports["reflectSymbol"] = reflectSymbol;
    exports["SProxy"] = SProxy;
})(PS);
(function(exports) {
    exports.unsafeGet = function(label) {
        return function(rec) {
            return rec[label];
        };
    };
})(PS["Record.Unsafe"] = PS["Record.Unsafe"] || {
});
(function($PS) {
    $PS["Record.Unsafe"] = $PS["Record.Unsafe"] || {
    };
    var exports = $PS["Record.Unsafe"];
    var $foreign = $PS["Record.Unsafe"];
    exports["unsafeGet"] = $foreign.unsafeGet;
})(PS);
(function($PS) {
    $PS["Type.Proxy"] = $PS["Type.Proxy"] || {
    };
    var exports = $PS["Type.Proxy"];
    var $$Proxy = function() {
        function $$Proxy1() {
        }
        $$Proxy1.value = new $$Proxy1();
        return $$Proxy1;
    }();
    exports["Proxy"] = $$Proxy;
})(PS);
(function($PS) {
    $PS["Data.Show"] = $PS["Data.Show"] || {
    };
    var exports = $PS["Data.Show"];
    var $foreign = $PS["Data.Show"];
    var Data_Symbol = $PS["Data.Symbol"];
    var Record_Unsafe = $PS["Record.Unsafe"];
    var Type_Proxy = $PS["Type.Proxy"];
    var ShowRecordFields = function(showRecordFields) {
        this.showRecordFields = showRecordFields;
    };
    var Show = function(show) {
        this.show = show;
    };
    var showString = new Show($foreign.showStringImpl);
    var showRecordFieldsNil = new ShowRecordFields(function(v) {
        return function(v1) {
            return [];
        };
    });
    var showRecordFields = function(dict) {
        return dict.showRecordFields;
    };
    var showRecord = function(dictRowToList) {
        return function(dictShowRecordFields) {
            return new Show(function(record) {
                var v = showRecordFields(dictShowRecordFields)(Type_Proxy["Proxy"].value)(record);
                if (v.length === 0) return "{}";
                return $foreign.join(" ")([
                    "{",
                    $foreign.join(", ")(v),
                    "}"
                ]);
            });
        };
    };
    var showInt = new Show($foreign.showIntImpl);
    var show = function(dict) {
        return dict.show;
    };
    var showArray = function(dictShow) {
        return new Show($foreign.showArrayImpl(show(dictShow)));
    };
    var showRecordFieldsCons = function(dictIsSymbol) {
        return function(dictShowRecordFields) {
            return function(dictShow) {
                return new ShowRecordFields(function(v) {
                    return function(record) {
                        var tail = showRecordFields(dictShowRecordFields)(Type_Proxy["Proxy"].value)(record);
                        var key = Data_Symbol.reflectSymbol(dictIsSymbol)(Type_Proxy["Proxy"].value);
                        var focus = Record_Unsafe.unsafeGet(key)(record);
                        return $foreign.cons($foreign.join(": ")([
                            key,
                            show(dictShow)(focus)
                        ]))(tail);
                    };
                });
            };
        };
    };
    exports["Show"] = Show;
    exports["show"] = show;
    exports["showInt"] = showInt;
    exports["showString"] = showString;
    exports["showArray"] = showArray;
    exports["showRecord"] = showRecord;
    exports["showRecordFieldsNil"] = showRecordFieldsNil;
    exports["showRecordFieldsCons"] = showRecordFieldsCons;
})(PS);
(function($PS) {
    $PS["Data.Maybe"] = $PS["Data.Maybe"] || {
    };
    var exports = $PS["Data.Maybe"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Control_Bind = $PS["Control.Bind"];
    var Control_Category = $PS["Control.Category"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_Show = $PS["Data.Show"];
    var Nothing = function() {
        function Nothing1() {
        }
        Nothing1.value = new Nothing1();
        return Nothing1;
    }();
    var Just = function() {
        function Just1(value0) {
            this.value0 = value0;
        }
        Just1.create = function(value0) {
            return new Just1(value0);
        };
        return Just1;
    }();
    var showMaybe = function(dictShow) {
        return new Data_Show.Show(function(v) {
            if (v instanceof Just) return "(Just " + (Data_Show.show(dictShow)(v.value0) + ")");
            if (v instanceof Nothing) return "Nothing";
            throw new Error("Failed pattern match at Data.Maybe (line 216, column 1 - line 218, column 28): " + [
                v.constructor.name
            ]);
        });
    };
    var maybe = function(v) {
        return function(v1) {
            return function(v2) {
                if (v2 instanceof Nothing) return v;
                if (v2 instanceof Just) return v1(v2.value0);
                throw new Error("Failed pattern match at Data.Maybe (line 230, column 1 - line 230, column 51): " + [
                    v.constructor.name,
                    v1.constructor.name,
                    v2.constructor.name
                ]);
            };
        };
    };
    var functorMaybe = new Data_Functor.Functor(function(v) {
        return function(v1) {
            if (v1 instanceof Just) return new Just(v(v1.value0));
            return Nothing.value;
        };
    });
    var fromMaybe = function(a) {
        return maybe(a)(Control_Category.identity(Control_Category.categoryFn));
    };
    var applyMaybe = new Control_Apply.Apply(function() {
        return functorMaybe;
    }, function(v) {
        return function(v1) {
            if (v instanceof Just) return Data_Functor.map(functorMaybe)(v.value0)(v1);
            if (v instanceof Nothing) return Nothing.value;
            throw new Error("Failed pattern match at Data.Maybe (line 68, column 1 - line 70, column 30): " + [
                v.constructor.name,
                v1.constructor.name
            ]);
        };
    });
    var bindMaybe = new Control_Bind.Bind(function() {
        return applyMaybe;
    }, function(v) {
        return function(v1) {
            if (v instanceof Just) return v1(v.value0);
            if (v instanceof Nothing) return Nothing.value;
            throw new Error("Failed pattern match at Data.Maybe (line 126, column 1 - line 128, column 28): " + [
                v.constructor.name,
                v1.constructor.name
            ]);
        };
    });
    var applicativeMaybe = new Control_Applicative.Applicative(function() {
        return applyMaybe;
    }, Just.create);
    exports["Nothing"] = Nothing;
    exports["Just"] = Just;
    exports["maybe"] = maybe;
    exports["fromMaybe"] = fromMaybe;
    exports["functorMaybe"] = functorMaybe;
    exports["applyMaybe"] = applyMaybe;
    exports["applicativeMaybe"] = applicativeMaybe;
    exports["bindMaybe"] = bindMaybe;
    exports["showMaybe"] = showMaybe;
})(PS);
(function($PS) {
    $PS["Data.MediaType.Common"] = $PS["Data.MediaType.Common"] || {
    };
    var exports = $PS["Data.MediaType.Common"];
    var applicationJSON = "application/json";
    var applicationFormURLEncoded = "application/x-www-form-urlencoded";
    exports["applicationFormURLEncoded"] = applicationFormURLEncoded;
    exports["applicationJSON"] = applicationJSON;
})(PS);
(function($PS) {
    $PS["Affjax.RequestBody"] = $PS["Affjax.RequestBody"] || {
    };
    var exports = $PS["Affjax.RequestBody"];
    var Data_Maybe = $PS["Data.Maybe"];
    var Data_MediaType_Common = $PS["Data.MediaType.Common"];
    var ArrayView = function() {
        function ArrayView1(value0) {
            this.value0 = value0;
        }
        ArrayView1.create = function(value0) {
            return new ArrayView1(value0);
        };
        return ArrayView1;
    }();
    var Blob1 = function() {
        function Blob2(value0) {
            this.value0 = value0;
        }
        Blob2.create = function(value0) {
            return new Blob2(value0);
        };
        return Blob2;
    }();
    var Document1 = function() {
        function Document2(value0) {
            this.value0 = value0;
        }
        Document2.create = function(value0) {
            return new Document2(value0);
        };
        return Document2;
    }();
    var $$String = function() {
        function $$String1(value0) {
            this.value0 = value0;
        }
        $$String1.create = function(value0) {
            return new $$String1(value0);
        };
        return $$String1;
    }();
    var FormData1 = function() {
        function FormData2(value0) {
            this.value0 = value0;
        }
        FormData2.create = function(value0) {
            return new FormData2(value0);
        };
        return FormData2;
    }();
    var FormURLEncoded = function() {
        function FormURLEncoded1(value0) {
            this.value0 = value0;
        }
        FormURLEncoded1.create = function(value0) {
            return new FormURLEncoded1(value0);
        };
        return FormURLEncoded1;
    }();
    var Json = function() {
        function Json1(value0) {
            this.value0 = value0;
        }
        Json1.create = function(value0) {
            return new Json1(value0);
        };
        return Json1;
    }();
    var toMediaType = function(v) {
        if (v instanceof FormURLEncoded) return new Data_Maybe.Just(Data_MediaType_Common.applicationFormURLEncoded);
        if (v instanceof Json) return new Data_Maybe.Just(Data_MediaType_Common.applicationJSON);
        return Data_Maybe.Nothing.value;
    };
    exports["ArrayView"] = ArrayView;
    exports["Blob"] = Blob1;
    exports["Document"] = Document1;
    exports["String"] = $$String;
    exports["FormData"] = FormData1;
    exports["FormURLEncoded"] = FormURLEncoded;
    exports["Json"] = Json;
    exports["toMediaType"] = toMediaType;
})(PS);
(function(exports) {
    // module Unsafe.Coerce
    exports.unsafeCoerce = function(x) {
        return x;
    };
})(PS["Unsafe.Coerce"] = PS["Unsafe.Coerce"] || {
});
(function($PS) {
    $PS["Unsafe.Coerce"] = $PS["Unsafe.Coerce"] || {
    };
    var exports = $PS["Unsafe.Coerce"];
    var $foreign = $PS["Unsafe.Coerce"];
    exports["unsafeCoerce"] = $foreign.unsafeCoerce;
})(PS);
(function($PS) {
    $PS["Safe.Coerce"] = $PS["Safe.Coerce"] || {
    };
    var exports = $PS["Safe.Coerce"];
    var Unsafe_Coerce = $PS["Unsafe.Coerce"];
    var coerce = function(dictCoercible) {
        return Unsafe_Coerce.unsafeCoerce;
    };
    exports["coerce"] = coerce;
})(PS);
(function($PS) {
    $PS["Data.Newtype"] = $PS["Data.Newtype"] || {
    };
    var exports = $PS["Data.Newtype"];
    var Safe_Coerce = $PS["Safe.Coerce"];
    var unwrap = function(dictNewtype) {
        return Safe_Coerce.coerce();
    };
    var alaF = function(dictCoercible) {
        return function(dictCoercible1) {
            return function(dictNewtype) {
                return function(dictNewtype1) {
                    return function(v) {
                        return Safe_Coerce.coerce();
                    };
                };
            };
        };
    };
    exports["unwrap"] = unwrap;
    exports["alaF"] = alaF;
})(PS);
(function($PS) {
    $PS["Affjax.RequestHeader"] = $PS["Affjax.RequestHeader"] || {
    };
    var exports = $PS["Affjax.RequestHeader"];
    var Data_Newtype = $PS["Data.Newtype"];
    var Accept = function() {
        function Accept1(value0) {
            this.value0 = value0;
        }
        Accept1.create = function(value0) {
            return new Accept1(value0);
        };
        return Accept1;
    }();
    var ContentType = function() {
        function ContentType1(value0) {
            this.value0 = value0;
        }
        ContentType1.create = function(value0) {
            return new ContentType1(value0);
        };
        return ContentType1;
    }();
    var RequestHeader = function() {
        function RequestHeader1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        RequestHeader1.create = function(value0) {
            return function(value1) {
                return new RequestHeader1(value0, value1);
            };
        };
        return RequestHeader1;
    }();
    var value = function(v) {
        if (v instanceof Accept) return Data_Newtype.unwrap()(v.value0);
        if (v instanceof ContentType) return Data_Newtype.unwrap()(v.value0);
        if (v instanceof RequestHeader) return v.value1;
        throw new Error("Failed pattern match at Affjax.RequestHeader (line 26, column 1 - line 26, column 33): " + [
            v.constructor.name
        ]);
    };
    var name = function(v) {
        if (v instanceof Accept) return "Accept";
        if (v instanceof ContentType) return "Content-Type";
        if (v instanceof RequestHeader) return v.value0;
        throw new Error("Failed pattern match at Affjax.RequestHeader (line 21, column 1 - line 21, column 32): " + [
            v.constructor.name
        ]);
    };
    exports["Accept"] = Accept;
    exports["ContentType"] = ContentType;
    exports["name"] = name;
    exports["value"] = value;
})(PS);
(function($PS) {
    $PS["Affjax.ResponseFormat"] = $PS["Affjax.ResponseFormat"] || {
    };
    var exports = $PS["Affjax.ResponseFormat"];
    var Control_Category = $PS["Control.Category"];
    var Data_Maybe = $PS["Data.Maybe"];
    var Data_MediaType_Common = $PS["Data.MediaType.Common"];
    var $$ArrayBuffer = function() {
        function $$ArrayBuffer1(value0) {
            this.value0 = value0;
        }
        $$ArrayBuffer1.create = function(value0) {
            return new $$ArrayBuffer1(value0);
        };
        return $$ArrayBuffer1;
    }();
    var Blob1 = function() {
        function Blob2(value0) {
            this.value0 = value0;
        }
        Blob2.create = function(value0) {
            return new Blob2(value0);
        };
        return Blob2;
    }();
    var Document1 = function() {
        function Document2(value0) {
            this.value0 = value0;
        }
        Document2.create = function(value0) {
            return new Document2(value0);
        };
        return Document2;
    }();
    var Json = function() {
        function Json1(value0) {
            this.value0 = value0;
        }
        Json1.create = function(value0) {
            return new Json1(value0);
        };
        return Json1;
    }();
    var $$String = function() {
        function $$String1(value0) {
            this.value0 = value0;
        }
        $$String1.create = function(value0) {
            return new $$String1(value0);
        };
        return $$String1;
    }();
    var Ignore = function() {
        function Ignore1(value0) {
            this.value0 = value0;
        }
        Ignore1.create = function(value0) {
            return new Ignore1(value0);
        };
        return Ignore1;
    }();
    var toResponseType = function(v) {
        if (v instanceof $$ArrayBuffer) return "arraybuffer";
        if (v instanceof Blob1) return "blob";
        if (v instanceof Document1) return "document";
        if (v instanceof Json) return "text";
        if (v instanceof $$String) return "text";
        if (v instanceof Ignore) return "";
        throw new Error("Failed pattern match at Affjax.ResponseFormat (line 44, column 3 - line 50, column 19): " + [
            v.constructor.name
        ]);
    };
    var toMediaType = function(v) {
        if (v instanceof Json) return new Data_Maybe.Just(Data_MediaType_Common.applicationJSON);
        return Data_Maybe.Nothing.value;
    };
    var string = new $$String(Control_Category.identity(Control_Category.categoryFn));
    var ignore = new Ignore(Control_Category.identity(Control_Category.categoryFn));
    exports["ArrayBuffer"] = $$ArrayBuffer;
    exports["Blob"] = Blob1;
    exports["Document"] = Document1;
    exports["Json"] = Json;
    exports["String"] = $$String;
    exports["Ignore"] = Ignore;
    exports["string"] = string;
    exports["ignore"] = ignore;
    exports["toResponseType"] = toResponseType;
    exports["toMediaType"] = toMediaType;
})(PS);
(function($PS) {
    $PS["Affjax.ResponseHeader"] = $PS["Affjax.ResponseHeader"] || {
    };
    var exports = $PS["Affjax.ResponseHeader"];
    var ResponseHeader = function() {
        function ResponseHeader1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        ResponseHeader1.create = function(value0) {
            return function(value1) {
                return new ResponseHeader1(value0, value1);
            };
        };
        return ResponseHeader1;
    }();
    exports["ResponseHeader"] = ResponseHeader;
})(PS);
(function($PS) {
    $PS["Control.Alt"] = $PS["Control.Alt"] || {
    };
    var exports = $PS["Control.Alt"];
    var Alt = function(Functor0, alt) {
        this.Functor0 = Functor0;
        this.alt = alt;
    };
    var alt = function(dict) {
        return dict.alt;
    };
    exports["Alt"] = Alt;
    exports["alt"] = alt;
})(PS);
(function($PS) {
    $PS["Data.Either"] = $PS["Data.Either"] || {
    };
    var exports = $PS["Data.Either"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_Maybe = $PS["Data.Maybe"];
    var Left = function() {
        function Left1(value0) {
            this.value0 = value0;
        }
        Left1.create = function(value0) {
            return new Left1(value0);
        };
        return Left1;
    }();
    var Right = function() {
        function Right1(value0) {
            this.value0 = value0;
        }
        Right1.create = function(value0) {
            return new Right1(value0);
        };
        return Right1;
    }();
    var note = function(a) {
        return Data_Maybe.maybe(new Left(a))(Right.create);
    };
    var functorEither = new Data_Functor.Functor(function(f) {
        return function(m) {
            if (m instanceof Left) return new Left(m.value0);
            if (m instanceof Right) return new Right(f(m.value0));
            throw new Error("Failed pattern match at Data.Either (line 31, column 1 - line 31, column 52): " + [
                m.constructor.name
            ]);
        };
    });
    var either = function(v) {
        return function(v1) {
            return function(v2) {
                if (v2 instanceof Left) return v(v2.value0);
                if (v2 instanceof Right) return v1(v2.value0);
                throw new Error("Failed pattern match at Data.Either (line 208, column 1 - line 208, column 64): " + [
                    v.constructor.name,
                    v1.constructor.name,
                    v2.constructor.name
                ]);
            };
        };
    };
    exports["Left"] = Left;
    exports["Right"] = Right;
    exports["either"] = either;
    exports["note"] = note;
    exports["functorEither"] = functorEither;
})(PS);
(function($PS) {
    $PS["Control.Monad.Error.Class"] = $PS["Control.Monad.Error.Class"] || {
    };
    var exports = $PS["Control.Monad.Error.Class"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Data_Either = $PS["Data.Either"];
    var Data_Functor = $PS["Data.Functor"];
    var MonadThrow = function(Monad0, throwError) {
        this.Monad0 = Monad0;
        this.throwError = throwError;
    };
    var MonadError = function(MonadThrow0, catchError) {
        this.MonadThrow0 = MonadThrow0;
        this.catchError = catchError;
    };
    var throwError = function(dict) {
        return dict.throwError;
    };
    var catchError = function(dict) {
        return dict.catchError;
    };
    var $$try = function(dictMonadError) {
        return function(a) {
            return catchError(dictMonadError)(Data_Functor.map(dictMonadError.MonadThrow0().Monad0().Bind1().Apply0().Functor0())(Data_Either.Right.create)(a))(function() {
                var $17 = Control_Applicative.pure(dictMonadError.MonadThrow0().Monad0().Applicative0());
                return function($18) {
                    return $17(Data_Either.Left.create($18));
                };
            }());
        };
    };
    exports["throwError"] = throwError;
    exports["MonadThrow"] = MonadThrow;
    exports["MonadError"] = MonadError;
    exports["try"] = $$try;
})(PS);
(function($PS) {
    $PS["Control.Monad"] = $PS["Control.Monad"] || {
    };
    var exports = $PS["Control.Monad"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Bind = $PS["Control.Bind"];
    var Monad = function(Applicative0, Bind1) {
        this.Applicative0 = Applicative0;
        this.Bind1 = Bind1;
    };
    var ap = function(dictMonad) {
        return function(f) {
            return function(a) {
                return Control_Bind.bind(dictMonad.Bind1())(f)(function(f$prime) {
                    return Control_Bind.bind(dictMonad.Bind1())(a)(function(a$prime) {
                        return Control_Applicative.pure(dictMonad.Applicative0())(f$prime(a$prime));
                    });
                });
            };
        };
    };
    exports["Monad"] = Monad;
    exports["ap"] = ap;
})(PS);
(function(exports) {
    exports.concatString = function(s1) {
        return function(s2) {
            return s1 + s2;
        };
    };
})(PS["Data.Semigroup"] = PS["Data.Semigroup"] || {
});
(function($PS) {
    $PS["Data.Semigroup"] = $PS["Data.Semigroup"] || {
    };
    var exports = $PS["Data.Semigroup"];
    var $foreign = $PS["Data.Semigroup"];
    var Semigroup = function(append) {
        this.append = append;
    };
    var semigroupString = new Semigroup($foreign.concatString);
    var append = function(dict) {
        return dict.append;
    };
    exports["Semigroup"] = Semigroup;
    exports["append"] = append;
    exports["semigroupString"] = semigroupString;
})(PS);
(function($PS) {
    $PS["Control.Monad.Except.Trans"] = $PS["Control.Monad.Except.Trans"] || {
    };
    var exports = $PS["Control.Monad.Except.Trans"];
    var Control_Alt = $PS["Control.Alt"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Control_Bind = $PS["Control.Bind"];
    var Control_Monad = $PS["Control.Monad"];
    var Control_Monad_Error_Class = $PS["Control.Monad.Error.Class"];
    var Data_Either = $PS["Data.Either"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_Semigroup = $PS["Data.Semigroup"];
    var ExceptT = function(x) {
        return x;
    };
    var withExceptT = function(dictFunctor) {
        return function(f) {
            return function(v) {
                var mapLeft = function(v1) {
                    return function(v2) {
                        if (v2 instanceof Data_Either.Right) return new Data_Either.Right(v2.value0);
                        if (v2 instanceof Data_Either.Left) return new Data_Either.Left(v1(v2.value0));
                        throw new Error("Failed pattern match at Control.Monad.Except.Trans (line 43, column 3 - line 43, column 32): " + [
                            v1.constructor.name,
                            v2.constructor.name
                        ]);
                    };
                };
                return ExceptT(Data_Functor.map(dictFunctor)(mapLeft(f))(v));
            };
        };
    };
    var runExceptT = function(v) {
        return v;
    };
    var mapExceptT = function(f) {
        return function(v) {
            return f(v);
        };
    };
    var functorExceptT = function(dictFunctor) {
        return new Data_Functor.Functor(function(f) {
            return mapExceptT(Data_Functor.map(dictFunctor)(Data_Functor.map(Data_Either.functorEither)(f)));
        });
    };
    var monadExceptT = function(dictMonad) {
        return new Control_Monad.Monad(function() {
            return applicativeExceptT(dictMonad);
        }, function() {
            return bindExceptT(dictMonad);
        });
    };
    var bindExceptT = function(dictMonad) {
        return new Control_Bind.Bind(function() {
            return applyExceptT(dictMonad);
        }, function(v) {
            return function(k) {
                return Control_Bind.bind(dictMonad.Bind1())(v)(Data_Either.either(function() {
                    var $91 = Control_Applicative.pure(dictMonad.Applicative0());
                    return function($92) {
                        return $91(Data_Either.Left.create($92));
                    };
                }())(function(a) {
                    var v1 = k(a);
                    return v1;
                }));
            };
        });
    };
    var applyExceptT = function(dictMonad) {
        return new Control_Apply.Apply(function() {
            return functorExceptT(dictMonad.Bind1().Apply0().Functor0());
        }, Control_Monad.ap(monadExceptT(dictMonad)));
    };
    var applicativeExceptT = function(dictMonad) {
        return new Control_Applicative.Applicative(function() {
            return applyExceptT(dictMonad);
        }, function() {
            var $93 = Control_Applicative.pure(dictMonad.Applicative0());
            return function($94) {
                return ExceptT($93(Data_Either.Right.create($94)));
            };
        }());
    };
    var monadThrowExceptT = function(dictMonad) {
        return new Control_Monad_Error_Class.MonadThrow(function() {
            return monadExceptT(dictMonad);
        }, function() {
            var $103 = Control_Applicative.pure(dictMonad.Applicative0());
            return function($104) {
                return ExceptT($103(Data_Either.Left.create($104)));
            };
        }());
    };
    var altExceptT = function(dictSemigroup) {
        return function(dictMonad) {
            return new Control_Alt.Alt(function() {
                return functorExceptT(dictMonad.Bind1().Apply0().Functor0());
            }, function(v) {
                return function(v1) {
                    return Control_Bind.bind(dictMonad.Bind1())(v)(function(rm) {
                        if (rm instanceof Data_Either.Right) return Control_Applicative.pure(dictMonad.Applicative0())(new Data_Either.Right(rm.value0));
                        if (rm instanceof Data_Either.Left) return Control_Bind.bind(dictMonad.Bind1())(v1)(function(rn) {
                            if (rn instanceof Data_Either.Right) return Control_Applicative.pure(dictMonad.Applicative0())(new Data_Either.Right(rn.value0));
                            if (rn instanceof Data_Either.Left) return Control_Applicative.pure(dictMonad.Applicative0())(new Data_Either.Left(Data_Semigroup.append(dictSemigroup)(rm.value0)(rn.value0)));
                            throw new Error("Failed pattern match at Control.Monad.Except.Trans (line 87, column 9 - line 89, column 49): " + [
                                rn.constructor.name
                            ]);
                        });
                        throw new Error("Failed pattern match at Control.Monad.Except.Trans (line 83, column 5 - line 89, column 49): " + [
                            rm.constructor.name
                        ]);
                    });
                };
            });
        };
    };
    exports["ExceptT"] = ExceptT;
    exports["runExceptT"] = runExceptT;
    exports["withExceptT"] = withExceptT;
    exports["functorExceptT"] = functorExceptT;
    exports["applicativeExceptT"] = applicativeExceptT;
    exports["bindExceptT"] = bindExceptT;
    exports["altExceptT"] = altExceptT;
    exports["monadThrowExceptT"] = monadThrowExceptT;
})(PS);
(function($PS) {
    $PS["Data.Identity"] = $PS["Data.Identity"] || {
    };
    var exports = $PS["Data.Identity"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Control_Bind = $PS["Control.Bind"];
    var Control_Monad = $PS["Control.Monad"];
    var Data_Functor = $PS["Data.Functor"];
    var Identity = function(x) {
        return x;
    };
    var functorIdentity = new Data_Functor.Functor(function(f) {
        return function(m) {
            return f(m);
        };
    });
    var applyIdentity = new Control_Apply.Apply(function() {
        return functorIdentity;
    }, function(v) {
        return function(v1) {
            return v(v1);
        };
    });
    var bindIdentity = new Control_Bind.Bind(function() {
        return applyIdentity;
    }, function(v) {
        return function(f) {
            return f(v);
        };
    });
    var applicativeIdentity = new Control_Applicative.Applicative(function() {
        return applyIdentity;
    }, Identity);
    var monadIdentity = new Control_Monad.Monad(function() {
        return applicativeIdentity;
    }, function() {
        return bindIdentity;
    });
    exports["Identity"] = Identity;
    exports["functorIdentity"] = functorIdentity;
    exports["applicativeIdentity"] = applicativeIdentity;
    exports["monadIdentity"] = monadIdentity;
})(PS);
(function($PS) {
    $PS["Control.Monad.Except"] = $PS["Control.Monad.Except"] || {
    };
    var exports = $PS["Control.Monad.Except"];
    var Control_Monad_Except_Trans = $PS["Control.Monad.Except.Trans"];
    var Data_Identity = $PS["Data.Identity"];
    var Data_Newtype = $PS["Data.Newtype"];
    var withExcept = Control_Monad_Except_Trans.withExceptT(Data_Identity.functorIdentity);
    var runExcept = function() {
        var $0 = Data_Newtype.unwrap();
        return function($1) {
            return $0(Control_Monad_Except_Trans.runExceptT($1));
        };
    }();
    exports["runExcept"] = runExcept;
    exports["withExcept"] = withExcept;
})(PS);
(function(exports) {
    function id(x) {
        return x;
    }
    exports.fromObject = id;
    exports.stringify = function(j) {
        return JSON.stringify(j);
    };
    function isArray(a) {
        return Object.prototype.toString.call(a) === "[object Array]";
    }
})(PS["Data.Argonaut.Core"] = PS["Data.Argonaut.Core"] || {
});
(function(exports) {
    exports.empty = {
    };
    function toArrayWithKey(f) {
        return function(m) {
            var r = [];
            for(var k in m)if (hasOwnProperty.call(m, k)) r.push(f(k)(m[k]));
            return r;
        };
    }
})(PS["Foreign.Object"] = PS["Foreign.Object"] || {
});
(function($PS) {
    $PS["Foreign.Object"] = $PS["Foreign.Object"] || {
    };
    var exports = $PS["Foreign.Object"];
    var $foreign = $PS["Foreign.Object"];
    exports["empty"] = $foreign.empty;
})(PS);
(function($PS) {
    $PS["Data.Argonaut.Core"] = $PS["Data.Argonaut.Core"] || {
    };
    var exports = $PS["Data.Argonaut.Core"];
    var $foreign = $PS["Data.Argonaut.Core"];
    var Foreign_Object = $PS["Foreign.Object"];
    var jsonEmptyObject = $foreign.fromObject(Foreign_Object.empty);
    exports["jsonEmptyObject"] = jsonEmptyObject;
    exports["stringify"] = $foreign.stringify;
})(PS);
(function(exports) {
    exports._jsonParser = function(fail, succ, s) {
        try {
            return succ(JSON.parse(s));
        } catch (e) {
            return fail(e.message);
        }
    };
})(PS["Data.Argonaut.Parser"] = PS["Data.Argonaut.Parser"] || {
});
(function($PS) {
    $PS["Data.Argonaut.Parser"] = $PS["Data.Argonaut.Parser"] || {
    };
    var exports = $PS["Data.Argonaut.Parser"];
    var $foreign = $PS["Data.Argonaut.Parser"];
    var Data_Either = $PS["Data.Either"];
    var jsonParser = function(j) {
        return $foreign["_jsonParser"](Data_Either.Left.create, Data_Either.Right.create, j);
    };
    exports["jsonParser"] = jsonParser;
})(PS);
(function(exports) {
    exports.pushAll = function(as) {
        return function(xs) {
            return function() {
                return xs.push.apply(xs, as);
            };
        };
    };
    exports.unsafeFreeze = function(xs) {
        return function() {
            return xs;
        };
    };
    function copyImpl(xs) {
        return function() {
            return xs.slice();
        };
    }
    exports.thaw = copyImpl;
})(PS["Data.Array.ST"] = PS["Data.Array.ST"] || {
});
(function($PS) {
    $PS["Data.Array.ST"] = $PS["Data.Array.ST"] || {
    };
    var exports = $PS["Data.Array.ST"];
    var $foreign = $PS["Data.Array.ST"];
    var withArray = function(f) {
        return function(xs) {
            return function __do() {
                var result = $foreign.thaw(xs)();
                f(result)();
                return $foreign.unsafeFreeze(result)();
            };
        };
    };
    var push = function(a) {
        return $foreign.pushAll([
            a
        ]);
    };
    exports["withArray"] = withArray;
    exports["push"] = push;
})(PS);
(function($PS) {
    $PS["Data.Array"] = $PS["Data.Array"] || {
    };
    var exports = $PS["Data.Array"];
    var Data_Array_ST = $PS["Data.Array.ST"];
    var snoc = function(xs) {
        return function(x) {
            return Data_Array_ST.withArray(Data_Array_ST.push(x))(xs)();
        };
    };
    exports["snoc"] = snoc;
})(PS);
(function(exports) {
    var refEq = function(r1) {
        return function(r2) {
            return r1 === r2;
        };
    };
    exports.eqStringImpl = refEq;
})(PS["Data.Eq"] = PS["Data.Eq"] || {
});
(function($PS) {
    $PS["Data.Eq"] = $PS["Data.Eq"] || {
    };
    var exports = $PS["Data.Eq"];
    var $foreign = $PS["Data.Eq"];
    var Eq = function(eq) {
        this.eq = eq;
    };
    var eqString = new Eq($foreign.eqStringImpl);
    var eq = function(dict) {
        return dict.eq;
    };
    exports["eq"] = eq;
    exports["eqString"] = eqString;
})(PS);
(function(exports) {
    exports.foldrArray = function(f) {
        return function(init) {
            return function(xs) {
                var acc = init;
                var len = xs.length;
                for(var i = len - 1; i >= 0; i--)acc = f(xs[i])(acc);
                return acc;
            };
        };
    };
    exports.foldlArray = function(f) {
        return function(init) {
            return function(xs) {
                var acc = init;
                var len = xs.length;
                for(var i = 0; i < len; i++)acc = f(acc)(xs[i]);
                return acc;
            };
        };
    };
})(PS["Data.Foldable"] = PS["Data.Foldable"] || {
});
(function($PS) {
    $PS["Data.Monoid"] = $PS["Data.Monoid"] || {
    };
    var exports = $PS["Data.Monoid"];
    var Data_Semigroup = $PS["Data.Semigroup"];
    var Monoid = function(Semigroup0, mempty) {
        this.Semigroup0 = Semigroup0;
        this.mempty = mempty;
    };
    var monoidString = new Monoid(function() {
        return Data_Semigroup.semigroupString;
    }, "");
    var mempty = function(dict) {
        return dict.mempty;
    };
    exports["Monoid"] = Monoid;
    exports["mempty"] = mempty;
    exports["monoidString"] = monoidString;
})(PS);
(function(exports) {
    exports.boolConj = function(b1) {
        return function(b2) {
            return b1 && b2;
        };
    };
    exports.boolDisj = function(b1) {
        return function(b2) {
            return b1 || b2;
        };
    };
    exports.boolNot = function(b) {
        return !b;
    };
})(PS["Data.HeytingAlgebra"] = PS["Data.HeytingAlgebra"] || {
});
(function($PS) {
    $PS["Data.HeytingAlgebra"] = $PS["Data.HeytingAlgebra"] || {
    };
    var exports = $PS["Data.HeytingAlgebra"];
    var $foreign = $PS["Data.HeytingAlgebra"];
    var HeytingAlgebra = function(conj, disj, ff, implies, not, tt) {
        this.conj = conj;
        this.disj = disj;
        this.ff = ff;
        this.implies = implies;
        this.not = not;
        this.tt = tt;
    };
    var not = function(dict) {
        return dict.not;
    };
    var ff = function(dict) {
        return dict.ff;
    };
    var disj = function(dict) {
        return dict.disj;
    };
    var heytingAlgebraBoolean = new HeytingAlgebra($foreign.boolConj, $foreign.boolDisj, false, function(a) {
        return function(b) {
            return disj(heytingAlgebraBoolean)(not(heytingAlgebraBoolean)(a))(b);
        };
    }, $foreign.boolNot, true);
    exports["ff"] = ff;
    exports["disj"] = disj;
    exports["heytingAlgebraBoolean"] = heytingAlgebraBoolean;
})(PS);
(function($PS) {
    $PS["Data.Monoid.Disj"] = $PS["Data.Monoid.Disj"] || {
    };
    var exports = $PS["Data.Monoid.Disj"];
    var Data_HeytingAlgebra = $PS["Data.HeytingAlgebra"];
    var Data_Monoid = $PS["Data.Monoid"];
    var Data_Semigroup = $PS["Data.Semigroup"];
    var Disj = function(x) {
        return x;
    };
    var semigroupDisj = function(dictHeytingAlgebra) {
        return new Data_Semigroup.Semigroup(function(v) {
            return function(v1) {
                return Data_HeytingAlgebra.disj(dictHeytingAlgebra)(v)(v1);
            };
        });
    };
    var monoidDisj = function(dictHeytingAlgebra) {
        return new Data_Monoid.Monoid(function() {
            return semigroupDisj(dictHeytingAlgebra);
        }, Data_HeytingAlgebra.ff(dictHeytingAlgebra));
    };
    exports["Disj"] = Disj;
    exports["monoidDisj"] = monoidDisj;
})(PS);
(function($PS) {
    $PS["Data.Foldable"] = $PS["Data.Foldable"] || {
    };
    var exports = $PS["Data.Foldable"];
    var $foreign = $PS["Data.Foldable"];
    var Data_Monoid = $PS["Data.Monoid"];
    var Data_Monoid_Disj = $PS["Data.Monoid.Disj"];
    var Data_Newtype = $PS["Data.Newtype"];
    var Data_Semigroup = $PS["Data.Semigroup"];
    var Foldable = function(foldMap, foldl, foldr) {
        this.foldMap = foldMap;
        this.foldl = foldl;
        this.foldr = foldr;
    };
    var foldr = function(dict) {
        return dict.foldr;
    };
    var foldl = function(dict) {
        return dict.foldl;
    };
    var intercalate = function(dictFoldable) {
        return function(dictMonoid) {
            return function(sep) {
                return function(xs) {
                    var go = function(v) {
                        return function(x) {
                            if (v.init) return {
                                init: false,
                                acc: x
                            };
                            return {
                                init: false,
                                acc: Data_Semigroup.append(dictMonoid.Semigroup0())(v.acc)(Data_Semigroup.append(dictMonoid.Semigroup0())(sep)(x))
                            };
                        };
                    };
                    return foldl(dictFoldable)(go)({
                        init: true,
                        acc: Data_Monoid.mempty(dictMonoid)
                    })(xs).acc;
                };
            };
        };
    };
    var foldMapDefaultR = function(dictFoldable) {
        return function(dictMonoid) {
            return function(f) {
                return foldr(dictFoldable)(function(x) {
                    return function(acc) {
                        return Data_Semigroup.append(dictMonoid.Semigroup0())(f(x))(acc);
                    };
                })(Data_Monoid.mempty(dictMonoid));
            };
        };
    };
    var foldableArray = new Foldable(function(dictMonoid) {
        return foldMapDefaultR(foldableArray)(dictMonoid);
    }, $foreign.foldlArray, $foreign.foldrArray);
    var foldMap = function(dict) {
        return dict.foldMap;
    };
    var any = function(dictFoldable) {
        return function(dictHeytingAlgebra) {
            return Data_Newtype.alaF()()()()(Data_Monoid_Disj.Disj)(foldMap(dictFoldable)(Data_Monoid_Disj.monoidDisj(dictHeytingAlgebra)));
        };
    };
    exports["Foldable"] = Foldable;
    exports["foldr"] = foldr;
    exports["foldl"] = foldl;
    exports["intercalate"] = intercalate;
    exports["any"] = any;
    exports["foldableArray"] = foldableArray;
})(PS);
(function(exports) {
    exports.joinWith = function(s) {
        return function(xs) {
            return xs.join(s);
        };
    };
})(PS["Data.String.Common"] = PS["Data.String.Common"] || {
});
(function($PS) {
    $PS["Data.String.Common"] = $PS["Data.String.Common"] || {
    };
    var exports = $PS["Data.String.Common"];
    var $foreign = $PS["Data.String.Common"];
    exports["joinWith"] = $foreign.joinWith;
})(PS);
(function(exports) {
    // jshint maxparams: 3
    exports.traverseArrayImpl = (function() {
        function array1(a) {
            return [
                a
            ];
        }
        function array2(a) {
            return function(b) {
                return [
                    a,
                    b
                ];
            };
        }
        function array3(a) {
            return function(b) {
                return function(c) {
                    return [
                        a,
                        b,
                        c
                    ];
                };
            };
        }
        function concat2(xs) {
            return function(ys) {
                return xs.concat(ys);
            };
        }
        return function(apply) {
            return function(map) {
                return function(pure) {
                    return function(f) {
                        return function(array) {
                            function go(bot, top) {
                                switch(top - bot){
                                    case 0:
                                        return pure([]);
                                    case 1:
                                        return map(array1)(f(array[bot]));
                                    case 2:
                                        return apply(map(array2)(f(array[bot])))(f(array[bot + 1]));
                                    case 3:
                                        return apply(apply(map(array3)(f(array[bot])))(f(array[bot + 1])))(f(array[bot + 2]));
                                    default:
                                        // This slightly tricky pivot selection aims to produce two
                                        // even-length partitions where possible.
                                        var pivot = bot + Math.floor((top - bot) / 4) * 2;
                                        return apply(map(concat2)(go(bot, pivot)))(go(pivot, top));
                                }
                            }
                            return go(0, array.length);
                        };
                    };
                };
            };
        };
    })();
})(PS["Data.Traversable"] = PS["Data.Traversable"] || {
});
(function($PS) {
    $PS["Data.Traversable"] = $PS["Data.Traversable"] || {
    };
    var exports = $PS["Data.Traversable"];
    var $foreign = $PS["Data.Traversable"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Control_Category = $PS["Control.Category"];
    var Data_Foldable = $PS["Data.Foldable"];
    var Data_Functor = $PS["Data.Functor"];
    var Traversable = function(Foldable1, Functor0, sequence, traverse) {
        this.Foldable1 = Foldable1;
        this.Functor0 = Functor0;
        this.sequence = sequence;
        this.traverse = traverse;
    };
    var traverse = function(dict) {
        return dict.traverse;
    };
    var sequenceDefault = function(dictTraversable) {
        return function(dictApplicative) {
            return traverse(dictTraversable)(dictApplicative)(Control_Category.identity(Control_Category.categoryFn));
        };
    };
    var traversableArray = new Traversable(function() {
        return Data_Foldable.foldableArray;
    }, function() {
        return Data_Functor.functorArray;
    }, function(dictApplicative) {
        return sequenceDefault(traversableArray)(dictApplicative);
    }, function(dictApplicative) {
        return $foreign.traverseArrayImpl(Control_Apply.apply(dictApplicative.Apply0()))(Data_Functor.map(dictApplicative.Apply0().Functor0()))(Control_Applicative.pure(dictApplicative));
    });
    var sequence = function(dict) {
        return dict.sequence;
    };
    exports["traverse"] = traverse;
    exports["sequence"] = sequence;
    exports["traversableArray"] = traversableArray;
})(PS);
(function(exports) {
    // A helper which transforms the result ofencodeURIComponent to be compliant
    // with RFC3896, as described in the MDN documentation here:
    //
    // https://web.archive.org/web/20201206001047/https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent
    function toRFC3896(input) {
        return input.replace(/[!'()*]/g, function(c) {
            return "%" + c.charCodeAt(0).toString(16);
        });
    }
    exports._encodeFormURLComponent = function encode(fail, succeed, input) {
        try {
            return succeed(toRFC3896(encodeURIComponent(input)).replace(/%20/g, "+"));
        } catch (err) {
            return fail(err);
        }
    };
    function _decodeURIComponent(fail, succeed, input) {
        try {
            return succeed(decodeURIComponent(input));
        } catch (err) {
            return fail(err);
        }
    }
})(PS["JSURI"] = PS["JSURI"] || {
});
(function(exports) {
    exports.runFn3 = function(fn) {
        return function(a) {
            return function(b) {
                return function(c) {
                    return fn(a, b, c);
                };
            };
        };
    };
})(PS["Data.Function.Uncurried"] = PS["Data.Function.Uncurried"] || {
});
(function($PS) {
    $PS["Data.Function.Uncurried"] = $PS["Data.Function.Uncurried"] || {
    };
    var exports = $PS["Data.Function.Uncurried"];
    var $foreign = $PS["Data.Function.Uncurried"];
    exports["runFn3"] = $foreign.runFn3;
})(PS);
(function($PS) {
    $PS["JSURI"] = $PS["JSURI"] || {
    };
    var exports = $PS["JSURI"];
    var $foreign = $PS["JSURI"];
    var Data_Function = $PS["Data.Function"];
    var Data_Function_Uncurried = $PS["Data.Function.Uncurried"];
    var Data_Maybe = $PS["Data.Maybe"];
    var encodeFormURLComponent = Data_Function_Uncurried.runFn3($foreign["_encodeFormURLComponent"])(Data_Function["const"](Data_Maybe.Nothing.value))(Data_Maybe.Just.create);
    exports["encodeFormURLComponent"] = encodeFormURLComponent;
})(PS);
(function($PS) {
    $PS["Data.FormURLEncoded"] = $PS["Data.FormURLEncoded"] || {
    };
    var exports = $PS["Data.FormURLEncoded"];
    var Control_Apply = $PS["Control.Apply"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_Maybe = $PS["Data.Maybe"];
    var Data_String_Common = $PS["Data.String.Common"];
    var Data_Traversable = $PS["Data.Traversable"];
    var JSURI = $PS["JSURI"];
    var toArray = function(v) {
        return v;
    };
    var encode = function() {
        var encodePart = function(v) {
            if (v.value1 instanceof Data_Maybe.Nothing) return JSURI.encodeFormURLComponent(v.value0);
            if (v.value1 instanceof Data_Maybe.Just) return Control_Apply.apply(Data_Maybe.applyMaybe)(Data_Functor.map(Data_Maybe.functorMaybe)(function(key) {
                return function(val) {
                    return key + ("=" + val);
                };
            })(JSURI.encodeFormURLComponent(v.value0)))(JSURI.encodeFormURLComponent(v.value1.value0));
            throw new Error("Failed pattern match at Data.FormURLEncoded (line 37, column 18 - line 39, column 116): " + [
                v.constructor.name
            ]);
        };
        var $16 = Data_Functor.map(Data_Maybe.functorMaybe)(Data_String_Common.joinWith("&"));
        var $17 = Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Maybe.applicativeMaybe)(encodePart);
        return function($18) {
            return $16($17(toArray($18)));
        };
    }();
    exports["encode"] = encode;
})(PS);
(function($PS) {
    $PS["Data.HTTP.Method"] = $PS["Data.HTTP.Method"] || {
    };
    var exports = $PS["Data.HTTP.Method"];
    var Data_Either = $PS["Data.Either"];
    var Data_Show = $PS["Data.Show"];
    var OPTIONS = function() {
        function OPTIONS1() {
        }
        OPTIONS1.value = new OPTIONS1();
        return OPTIONS1;
    }();
    var GET = function() {
        function GET1() {
        }
        GET1.value = new GET1();
        return GET1;
    }();
    var HEAD = function() {
        function HEAD1() {
        }
        HEAD1.value = new HEAD1();
        return HEAD1;
    }();
    var POST = function() {
        function POST1() {
        }
        POST1.value = new POST1();
        return POST1;
    }();
    var PUT = function() {
        function PUT1() {
        }
        PUT1.value = new PUT1();
        return PUT1;
    }();
    var DELETE = function() {
        function DELETE1() {
        }
        DELETE1.value = new DELETE1();
        return DELETE1;
    }();
    var TRACE = function() {
        function TRACE1() {
        }
        TRACE1.value = new TRACE1();
        return TRACE1;
    }();
    var CONNECT = function() {
        function CONNECT1() {
        }
        CONNECT1.value = new CONNECT1();
        return CONNECT1;
    }();
    var PROPFIND = function() {
        function PROPFIND1() {
        }
        PROPFIND1.value = new PROPFIND1();
        return PROPFIND1;
    }();
    var PROPPATCH = function() {
        function PROPPATCH1() {
        }
        PROPPATCH1.value = new PROPPATCH1();
        return PROPPATCH1;
    }();
    var MKCOL = function() {
        function MKCOL1() {
        }
        MKCOL1.value = new MKCOL1();
        return MKCOL1;
    }();
    var COPY = function() {
        function COPY1() {
        }
        COPY1.value = new COPY1();
        return COPY1;
    }();
    var MOVE = function() {
        function MOVE1() {
        }
        MOVE1.value = new MOVE1();
        return MOVE1;
    }();
    var LOCK = function() {
        function LOCK1() {
        }
        LOCK1.value = new LOCK1();
        return LOCK1;
    }();
    var UNLOCK = function() {
        function UNLOCK1() {
        }
        UNLOCK1.value = new UNLOCK1();
        return UNLOCK1;
    }();
    var PATCH = function() {
        function PATCH1() {
        }
        PATCH1.value = new PATCH1();
        return PATCH1;
    }();
    var unCustomMethod = function(v) {
        return v;
    };
    var showMethod = new Data_Show.Show(function(v) {
        if (v instanceof OPTIONS) return "OPTIONS";
        if (v instanceof GET) return "GET";
        if (v instanceof HEAD) return "HEAD";
        if (v instanceof POST) return "POST";
        if (v instanceof PUT) return "PUT";
        if (v instanceof DELETE) return "DELETE";
        if (v instanceof TRACE) return "TRACE";
        if (v instanceof CONNECT) return "CONNECT";
        if (v instanceof PROPFIND) return "PROPFIND";
        if (v instanceof PROPPATCH) return "PROPPATCH";
        if (v instanceof MKCOL) return "MKCOL";
        if (v instanceof COPY) return "COPY";
        if (v instanceof MOVE) return "MOVE";
        if (v instanceof LOCK) return "LOCK";
        if (v instanceof UNLOCK) return "UNLOCK";
        if (v instanceof PATCH) return "PATCH";
        throw new Error("Failed pattern match at Data.HTTP.Method (line 43, column 1 - line 59, column 23): " + [
            v.constructor.name
        ]);
    });
    var print = Data_Either.either(Data_Show.show(showMethod))(unCustomMethod);
    exports["GET"] = GET;
    exports["print"] = print;
})(PS);
(function($PS) {
    $PS["Control.Plus"] = $PS["Control.Plus"] || {
    };
    var exports = $PS["Control.Plus"];
    var Plus = function(Alt0, empty) {
        this.Alt0 = Alt0;
        this.empty = empty;
    };
    var empty = function(dict) {
        return dict.empty;
    };
    exports["Plus"] = Plus;
    exports["empty"] = empty;
})(PS);
(function($PS) {
    $PS["Data.NonEmpty"] = $PS["Data.NonEmpty"] || {
    };
    var exports = $PS["Data.NonEmpty"];
    var Control_Plus = $PS["Control.Plus"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_Show = $PS["Data.Show"];
    var NonEmpty = function() {
        function NonEmpty1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        NonEmpty1.create = function(value0) {
            return function(value1) {
                return new NonEmpty1(value0, value1);
            };
        };
        return NonEmpty1;
    }();
    var singleton = function(dictPlus) {
        return function(a) {
            return new NonEmpty(a, Control_Plus.empty(dictPlus));
        };
    };
    var showNonEmpty = function(dictShow) {
        return function(dictShow1) {
            return new Data_Show.Show(function(v) {
                return "(NonEmpty " + (Data_Show.show(dictShow)(v.value0) + (" " + (Data_Show.show(dictShow1)(v.value1) + ")")));
            });
        };
    };
    var functorNonEmpty = function(dictFunctor) {
        return new Data_Functor.Functor(function(f) {
            return function(m) {
                return new NonEmpty(f(m.value0), Data_Functor.map(dictFunctor)(f)(m.value1));
            };
        });
    };
    exports["NonEmpty"] = NonEmpty;
    exports["singleton"] = singleton;
    exports["showNonEmpty"] = showNonEmpty;
    exports["functorNonEmpty"] = functorNonEmpty;
})(PS);
(function($PS) {
    $PS["Data.List.Types"] = $PS["Data.List.Types"] || {
    };
    var exports = $PS["Data.List.Types"];
    var Control_Alt = $PS["Control.Alt"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Control_Plus = $PS["Control.Plus"];
    var Data_Foldable = $PS["Data.Foldable"];
    var Data_Function = $PS["Data.Function"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_Monoid = $PS["Data.Monoid"];
    var Data_NonEmpty = $PS["Data.NonEmpty"];
    var Data_Semigroup = $PS["Data.Semigroup"];
    var Data_Show = $PS["Data.Show"];
    var Nil = function() {
        function Nil1() {
        }
        Nil1.value = new Nil1();
        return Nil1;
    }();
    var Cons = function() {
        function Cons1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        Cons1.create = function(value0) {
            return function(value1) {
                return new Cons1(value0, value1);
            };
        };
        return Cons1;
    }();
    var NonEmptyList = function(x) {
        return x;
    };
    var toList = function(v) {
        return new Cons(v.value0, v.value1);
    };
    var listMap = function(f) {
        var chunkedRevMap = function($copy_chunksAcc) {
            return function($copy_v) {
                var $tco_var_chunksAcc = $copy_chunksAcc;
                var $tco_done = false;
                var $tco_result;
                function $tco_loop(chunksAcc, v) {
                    if (v instanceof Cons && v.value1 instanceof Cons && v.value1.value1 instanceof Cons) {
                        $tco_var_chunksAcc = new Cons(v, chunksAcc);
                        $copy_v = v.value1.value1.value1;
                        return;
                    }
                    var unrolledMap = function(v1) {
                        if (v1 instanceof Cons && v1.value1 instanceof Cons && v1.value1.value1 instanceof Nil) return new Cons(f(v1.value0), new Cons(f(v1.value1.value0), Nil.value));
                        if (v1 instanceof Cons && v1.value1 instanceof Nil) return new Cons(f(v1.value0), Nil.value);
                        return Nil.value;
                    };
                    var reverseUnrolledMap = function($copy_v1) {
                        return function($copy_acc) {
                            var $tco_var_v1 = $copy_v1;
                            var $tco_done1 = false;
                            var $tco_result1;
                            function $tco_loop1(v1, acc) {
                                if (v1 instanceof Cons && v1.value0 instanceof Cons && v1.value0.value1 instanceof Cons && v1.value0.value1.value1 instanceof Cons) {
                                    $tco_var_v1 = v1.value1;
                                    $copy_acc = new Cons(f(v1.value0.value0), new Cons(f(v1.value0.value1.value0), new Cons(f(v1.value0.value1.value1.value0), acc)));
                                    return;
                                }
                                $tco_done1 = true;
                                return acc;
                            }
                            while(!$tco_done1)$tco_result1 = $tco_loop1($tco_var_v1, $copy_acc);
                            return $tco_result1;
                        };
                    };
                    $tco_done = true;
                    return reverseUnrolledMap(chunksAcc)(unrolledMap(v));
                }
                while(!$tco_done)$tco_result = $tco_loop($tco_var_chunksAcc, $copy_v);
                return $tco_result;
            };
        };
        return chunkedRevMap(Nil.value);
    };
    var functorList = new Data_Functor.Functor(listMap);
    var functorNonEmptyList = Data_NonEmpty.functorNonEmpty(functorList);
    var foldableList = new Data_Foldable.Foldable(function(dictMonoid) {
        return function(f) {
            return Data_Foldable.foldl(foldableList)(function(acc) {
                var $205 = Data_Semigroup.append(dictMonoid.Semigroup0())(acc);
                return function($206) {
                    return $205(f($206));
                };
            })(Data_Monoid.mempty(dictMonoid));
        };
    }, function(f) {
        var go = function($copy_b) {
            return function($copy_v) {
                var $tco_var_b = $copy_b;
                var $tco_done = false;
                var $tco_result;
                function $tco_loop(b, v) {
                    if (v instanceof Nil) {
                        $tco_done = true;
                        return b;
                    }
                    if (v instanceof Cons) {
                        $tco_var_b = f(b)(v.value0);
                        $copy_v = v.value1;
                        return;
                    }
                    throw new Error("Failed pattern match at Data.List.Types (line 112, column 12 - line 114, column 30): " + [
                        v.constructor.name
                    ]);
                }
                while(!$tco_done)$tco_result = $tco_loop($tco_var_b, $copy_v);
                return $tco_result;
            };
        };
        return go;
    }, function(f) {
        return function(b) {
            var rev = function() {
                var go = function($copy_acc) {
                    return function($copy_v) {
                        var $tco_var_acc = $copy_acc;
                        var $tco_done1 = false;
                        var $tco_result;
                        function $tco_loop(acc, v) {
                            if (v instanceof Nil) {
                                $tco_done1 = true;
                                return acc;
                            }
                            if (v instanceof Cons) {
                                $tco_var_acc = new Cons(v.value0, acc);
                                $copy_v = v.value1;
                                return;
                            }
                            throw new Error("Failed pattern match at Data.List.Types (line 108, column 7 - line 108, column 23): " + [
                                acc.constructor.name,
                                v.constructor.name
                            ]);
                        }
                        while(!$tco_done1)$tco_result = $tco_loop($tco_var_acc, $copy_v);
                        return $tco_result;
                    };
                };
                return go(Nil.value);
            }();
            var $207 = Data_Foldable.foldl(foldableList)(Data_Function.flip(f))(b);
            return function($208) {
                return $207(rev($208));
            };
        };
    });
    var semigroupList = new Data_Semigroup.Semigroup(function(xs) {
        return function(ys) {
            return Data_Foldable.foldr(foldableList)(Cons.create)(ys)(xs);
        };
    });
    var semigroupNonEmptyList = new Data_Semigroup.Semigroup(function(v) {
        return function(as$prime) {
            return new Data_NonEmpty.NonEmpty(v.value0, Data_Semigroup.append(semigroupList)(v.value1)(toList(as$prime)));
        };
    });
    var showList = function(dictShow) {
        return new Data_Show.Show(function(v) {
            if (v instanceof Nil) return "Nil";
            return "(" + (Data_Foldable.intercalate(foldableList)(Data_Monoid.monoidString)(" : ")(Data_Functor.map(functorList)(Data_Show.show(dictShow))(v)) + " : Nil)");
        });
    };
    var showNonEmptyList = function(dictShow) {
        return new Data_Show.Show(function(v) {
            return "(NonEmptyList " + (Data_Show.show(Data_NonEmpty.showNonEmpty(dictShow)(showList(dictShow)))(v) + ")");
        });
    };
    var applyList = new Control_Apply.Apply(function() {
        return functorList;
    }, function(v) {
        return function(v1) {
            if (v instanceof Nil) return Nil.value;
            if (v instanceof Cons) return Data_Semigroup.append(semigroupList)(Data_Functor.map(functorList)(v.value0)(v1))(Control_Apply.apply(applyList)(v.value1)(v1));
            throw new Error("Failed pattern match at Data.List.Types (line 158, column 1 - line 160, column 48): " + [
                v.constructor.name,
                v1.constructor.name
            ]);
        };
    });
    var applyNonEmptyList = new Control_Apply.Apply(function() {
        return functorNonEmptyList;
    }, function(v) {
        return function(v1) {
            return new Data_NonEmpty.NonEmpty(v.value0(v1.value0), Data_Semigroup.append(semigroupList)(Control_Apply.apply(applyList)(v.value1)(new Cons(v1.value0, Nil.value)))(Control_Apply.apply(applyList)(new Cons(v.value0, v.value1))(v1.value1)));
        };
    });
    var altList = new Control_Alt.Alt(function() {
        return functorList;
    }, Data_Semigroup.append(semigroupList));
    var plusList = new Control_Plus.Plus(function() {
        return altList;
    }, Nil.value);
    var applicativeNonEmptyList = new Control_Applicative.Applicative(function() {
        return applyNonEmptyList;
    }, function() {
        var $236 = Data_NonEmpty.singleton(plusList);
        return function($237) {
            return NonEmptyList($236($237));
        };
    }());
    exports["NonEmptyList"] = NonEmptyList;
    exports["plusList"] = plusList;
    exports["showNonEmptyList"] = showNonEmptyList;
    exports["functorNonEmptyList"] = functorNonEmptyList;
    exports["applicativeNonEmptyList"] = applicativeNonEmptyList;
    exports["semigroupNonEmptyList"] = semigroupNonEmptyList;
})(PS);
(function($PS) {
    $PS["Data.List.NonEmpty"] = $PS["Data.List.NonEmpty"] || {
    };
    var exports = $PS["Data.List.NonEmpty"];
    var Data_List_Types = $PS["Data.List.Types"];
    var Data_NonEmpty = $PS["Data.NonEmpty"];
    var singleton = function() {
        var $172 = Data_NonEmpty.singleton(Data_List_Types.plusList);
        return function($173) {
            return Data_List_Types.NonEmptyList($172($173));
        };
    }();
    var head = function(v) {
        return v.value0;
    };
    exports["singleton"] = singleton;
    exports["head"] = head;
})(PS);
(function(exports) {
    exports["null"] = null;
    exports.notNull = function(x) {
        return x;
    };
})(PS["Data.Nullable"] = PS["Data.Nullable"] || {
});
(function($PS) {
    $PS["Data.Nullable"] = $PS["Data.Nullable"] || {
    };
    var exports = $PS["Data.Nullable"];
    var $foreign = $PS["Data.Nullable"];
    var Data_Maybe = $PS["Data.Maybe"];
    var toNullable = Data_Maybe.maybe($foreign["null"])($foreign.notNull);
    exports["toNullable"] = toNullable;
})(PS);
(function(exports) {
    var Aff = function() {
        // A unique value for empty.
        var EMPTY = {
        };
        /*

  An awkward approximation. We elide evidence we would otherwise need in PS for
  efficiency sake.

  data Aff eff a
    = Pure a
    | Throw Error
    | Catch (Aff eff a) (Error -> Aff eff a)
    | Sync (Eff eff a)
    | Async ((Either Error a -> Eff eff Unit) -> Eff eff (Canceler eff))
    | forall b. Bind (Aff eff b) (b -> Aff eff a)
    | forall b. Bracket (Aff eff b) (BracketConditions eff b) (b -> Aff eff a)
    | forall b. Fork Boolean (Aff eff b) ?(Fiber eff b -> a)
    | Sequential (ParAff aff a)

  */ var PURE = "Pure";
        var THROW = "Throw";
        var CATCH = "Catch";
        var SYNC = "Sync";
        var ASYNC = "Async";
        var BIND = "Bind";
        var BRACKET = "Bracket";
        var FORK = "Fork";
        var SEQ = "Sequential";
        /*

  data ParAff eff a
    = forall b. Map (b -> a) (ParAff eff b)
    | forall b. Apply (ParAff eff (b -> a)) (ParAff eff b)
    | Alt (ParAff eff a) (ParAff eff a)
    | ?Par (Aff eff a)

  */ var MAP = "Map";
        var APPLY = "Apply";
        var ALT = "Alt";
        // Various constructors used in interpretation
        var CONS = "Cons"; // Cons-list, for stacks
        var RESUME = "Resume"; // Continue indiscriminately
        var RELEASE = "Release"; // Continue with bracket finalizers
        var FINALIZER = "Finalizer"; // A non-interruptible effect
        var FINALIZED = "Finalized"; // Marker for finalization
        var FORKED = "Forked"; // Reference to a forked fiber, with resumption stack
        var FIBER = "Fiber"; // Actual fiber reference
        var THUNK = "Thunk"; // Primed effect, ready to invoke
        function Aff1(tag, _1, _2, _3) {
            this.tag = tag;
            this._1 = _1;
            this._2 = _2;
            this._3 = _3;
        }
        function AffCtr(tag) {
            var fn = function(_1, _2, _3) {
                return new Aff1(tag, _1, _2, _3);
            };
            fn.tag = tag;
            return fn;
        }
        function nonCanceler(error) {
            return new Aff1(PURE, void 0);
        }
        function runEff(eff) {
            try {
                eff();
            } catch (error) {
                setTimeout(function() {
                    throw error;
                }, 0);
            }
        }
        function runSync(left, right, eff) {
            try {
                return right(eff());
            } catch (error) {
                return left(error);
            }
        }
        function runAsync(left, eff, k) {
            try {
                return eff(k)();
            } catch (error) {
                k(left(error))();
                return nonCanceler;
            }
        }
        var Scheduler = function() {
            var limit = 1024;
            var size = 0;
            var ix = 0;
            var queue = new Array(limit);
            var draining = false;
            function drain() {
                var thunk;
                draining = true;
                while(size !== 0){
                    size--;
                    thunk = queue[ix];
                    queue[ix] = void 0;
                    ix = (ix + 1) % limit;
                    thunk();
                }
                draining = false;
            }
            return {
                isDraining: function() {
                    return draining;
                },
                enqueue: function(cb) {
                    var i, tmp;
                    if (size === limit) {
                        tmp = draining;
                        drain();
                        draining = tmp;
                    }
                    queue[(ix + size) % limit] = cb;
                    size++;
                    if (!draining) drain();
                }
            };
        }();
        function Supervisor(util) {
            var fibers = {
            };
            var fiberId = 0;
            var count = 0;
            return {
                register: function(fiber) {
                    var fid = fiberId++;
                    fiber.onComplete({
                        rethrow: true,
                        handler: function(result) {
                            return function() {
                                count--;
                                delete fibers[fid];
                            };
                        }
                    })();
                    fibers[fid] = fiber;
                    count++;
                },
                isEmpty: function() {
                    return count === 0;
                },
                killAll: function(killError, cb) {
                    return function() {
                        if (count === 0) return cb();
                        var killCount = 0;
                        var kills = {
                        };
                        function kill(fid) {
                            kills[fid] = fibers[fid].kill(killError, function(result) {
                                return function() {
                                    delete kills[fid];
                                    killCount--;
                                    if (util.isLeft(result) && util.fromLeft(result)) setTimeout(function() {
                                        throw util.fromLeft(result);
                                    }, 0);
                                    if (killCount === 0) cb();
                                };
                            })();
                        }
                        for(var k in fibers)if (fibers.hasOwnProperty(k)) {
                            killCount++;
                            kill(k);
                        }
                        fibers = {
                        };
                        fiberId = 0;
                        count = 0;
                        return function(error) {
                            return new Aff1(SYNC, function() {
                                for(var k1 in kills)if (kills.hasOwnProperty(k1)) kills[k1]();
                            });
                        };
                    };
                }
            };
        }
        // Fiber state machine
        var SUSPENDED = 0; // Suspended, pending a join.
        var CONTINUE = 1; // Interpret the next instruction.
        var STEP_BIND = 2; // Apply the next bind.
        var STEP_RESULT = 3; // Handle potential failure from a result.
        var PENDING = 4; // An async effect is running.
        var RETURN = 5; // The current stack has returned.
        var COMPLETED = 6; // The entire fiber has completed.
        function Fiber(util, supervisor, aff) {
            // Monotonically increasing tick, increased on each asynchronous turn.
            var runTick = 0;
            // The current branch of the state machine.
            var status = SUSPENDED;
            // The current point of interest for the state machine branch.
            var step = aff; // Successful step
            var fail = null; // Failure step
            var interrupt = null; // Asynchronous interrupt
            // Stack of continuations for the current fiber.
            var bhead = null;
            var btail = null;
            // Stack of attempts and finalizers for error recovery. Every `Cons` is also
            // tagged with current `interrupt` state. We use this to track which items
            // should be ignored or evaluated as a result of a kill.
            var attempts = null;
            // A special state is needed for Bracket, because it cannot be killed. When
            // we enter a bracket acquisition or finalizer, we increment the counter,
            // and then decrement once complete.
            var bracketCount = 0;
            // Each join gets a new id so they can be revoked.
            var joinId = 0;
            var joins = null;
            var rethrow = true;
            // Each invocation of `run` requires a tick. When an asynchronous effect is
            // resolved, we must check that the local tick coincides with the fiber
            // tick before resuming. This prevents multiple async continuations from
            // accidentally resuming the same fiber. A common example may be invoking
            // the provided callback in `makeAff` more than once, but it may also be an
            // async effect resuming after the fiber was already cancelled.
            function run(localRunTick) {
                var tmp, result, attempt;
                while(true){
                    tmp = null;
                    result = null;
                    attempt = null;
                    switch(status){
                        case STEP_BIND:
                            status = CONTINUE;
                            try {
                                step = bhead(step);
                                if (btail === null) bhead = null;
                                else {
                                    bhead = btail._1;
                                    btail = btail._2;
                                }
                            } catch (e) {
                                status = RETURN;
                                fail = util.left(e);
                                step = null;
                            }
                            break;
                        case STEP_RESULT:
                            if (util.isLeft(step)) {
                                status = RETURN;
                                fail = step;
                                step = null;
                            } else if (bhead === null) status = RETURN;
                            else {
                                status = STEP_BIND;
                                step = util.fromRight(step);
                            }
                            break;
                        case CONTINUE:
                            switch(step.tag){
                                case BIND:
                                    if (bhead) btail = new Aff1(CONS, bhead, btail);
                                    bhead = step._2;
                                    status = CONTINUE;
                                    step = step._1;
                                    break;
                                case PURE:
                                    if (bhead === null) {
                                        status = RETURN;
                                        step = util.right(step._1);
                                    } else {
                                        status = STEP_BIND;
                                        step = step._1;
                                    }
                                    break;
                                case SYNC:
                                    status = STEP_RESULT;
                                    step = runSync(util.left, util.right, step._1);
                                    break;
                                case ASYNC:
                                    status = PENDING;
                                    step = runAsync(util.left, step._1, function(result1) {
                                        return function() {
                                            if (runTick !== localRunTick) return;
                                            runTick++;
                                            Scheduler.enqueue(function() {
                                                // It's possible to interrupt the fiber between enqueuing and
                                                // resuming, so we need to check that the runTick is still
                                                // valid.
                                                if (runTick !== localRunTick + 1) return;
                                                status = STEP_RESULT;
                                                step = result1;
                                                run(runTick);
                                            });
                                        };
                                    });
                                    return;
                                case THROW:
                                    status = RETURN;
                                    fail = util.left(step._1);
                                    step = null;
                                    break;
                                // Enqueue the Catch so that we can call the error handler later on
                                // in case of an exception.
                                case CATCH:
                                    if (bhead === null) attempts = new Aff1(CONS, step, attempts, interrupt);
                                    else attempts = new Aff1(CONS, step, new Aff1(CONS, new Aff1(RESUME, bhead, btail), attempts, interrupt), interrupt);
                                    bhead = null;
                                    btail = null;
                                    status = CONTINUE;
                                    step = step._1;
                                    break;
                                // Enqueue the Bracket so that we can call the appropriate handlers
                                // after resource acquisition.
                                case BRACKET:
                                    bracketCount++;
                                    if (bhead === null) attempts = new Aff1(CONS, step, attempts, interrupt);
                                    else attempts = new Aff1(CONS, step, new Aff1(CONS, new Aff1(RESUME, bhead, btail), attempts, interrupt), interrupt);
                                    bhead = null;
                                    btail = null;
                                    status = CONTINUE;
                                    step = step._1;
                                    break;
                                case FORK:
                                    status = STEP_RESULT;
                                    tmp = Fiber(util, supervisor, step._2);
                                    if (supervisor) supervisor.register(tmp);
                                    if (step._1) tmp.run();
                                    step = util.right(tmp);
                                    break;
                                case SEQ:
                                    status = CONTINUE;
                                    step = sequential(util, supervisor, step._1);
                                    break;
                            }
                            break;
                        case RETURN:
                            bhead = null;
                            btail = null;
                            // If the current stack has returned, and we have no other stacks to
                            // resume or finalizers to run, the fiber has halted and we can
                            // invoke all join callbacks. Otherwise we need to resume.
                            if (attempts === null) {
                                status = COMPLETED;
                                step = interrupt || fail || step;
                            } else {
                                // The interrupt status for the enqueued item.
                                tmp = attempts._3;
                                attempt = attempts._1;
                                attempts = attempts._2;
                                switch(attempt.tag){
                                    // We cannot recover from an unmasked interrupt. Otherwise we should
                                    // continue stepping, or run the exception handler if an exception
                                    // was raised.
                                    case CATCH:
                                        // We should compare the interrupt status as well because we
                                        // only want it to apply if there has been an interrupt since
                                        // enqueuing the catch.
                                        if (interrupt && interrupt !== tmp && bracketCount === 0) status = RETURN;
                                        else if (fail) {
                                            status = CONTINUE;
                                            step = attempt._2(util.fromLeft(fail));
                                            fail = null;
                                        }
                                        break;
                                    // We cannot resume from an unmasked interrupt or exception.
                                    case RESUME:
                                        // As with Catch, we only want to ignore in the case of an
                                        // interrupt since enqueing the item.
                                        if (interrupt && interrupt !== tmp && bracketCount === 0 || fail) status = RETURN;
                                        else {
                                            bhead = attempt._1;
                                            btail = attempt._2;
                                            status = STEP_BIND;
                                            step = util.fromRight(step);
                                        }
                                        break;
                                    // If we have a bracket, we should enqueue the handlers,
                                    // and continue with the success branch only if the fiber has
                                    // not been interrupted. If the bracket acquisition failed, we
                                    // should not run either.
                                    case BRACKET:
                                        bracketCount--;
                                        if (fail === null) {
                                            result = util.fromRight(step);
                                            // We need to enqueue the Release with the same interrupt
                                            // status as the Bracket that is initiating it.
                                            attempts = new Aff1(CONS, new Aff1(RELEASE, attempt._2, result), attempts, tmp);
                                            // We should only coninue as long as the interrupt status has not changed or
                                            // we are currently within a non-interruptable finalizer.
                                            if (interrupt === tmp || bracketCount > 0) {
                                                status = CONTINUE;
                                                step = attempt._3(result);
                                            }
                                        }
                                        break;
                                    // Enqueue the appropriate handler. We increase the bracket count
                                    // because it should not be cancelled.
                                    case RELEASE:
                                        attempts = new Aff1(CONS, new Aff1(FINALIZED, step, fail), attempts, interrupt);
                                        status = CONTINUE;
                                        // It has only been killed if the interrupt status has changed
                                        // since we enqueued the item, and the bracket count is 0. If the
                                        // bracket count is non-zero then we are in a masked state so it's
                                        // impossible to be killed.
                                        if (interrupt && interrupt !== tmp && bracketCount === 0) step = attempt._1.killed(util.fromLeft(interrupt))(attempt._2);
                                        else if (fail) step = attempt._1.failed(util.fromLeft(fail))(attempt._2);
                                        else step = attempt._1.completed(util.fromRight(step))(attempt._2);
                                        fail = null;
                                        bracketCount++;
                                        break;
                                    case FINALIZER:
                                        bracketCount++;
                                        attempts = new Aff1(CONS, new Aff1(FINALIZED, step, fail), attempts, interrupt);
                                        status = CONTINUE;
                                        step = attempt._1;
                                        break;
                                    case FINALIZED:
                                        bracketCount--;
                                        status = RETURN;
                                        step = attempt._1;
                                        fail = attempt._2;
                                        break;
                                }
                            }
                            break;
                        case COMPLETED:
                            for(var k in joins)if (joins.hasOwnProperty(k)) {
                                rethrow = rethrow && joins[k].rethrow;
                                runEff(joins[k].handler(step));
                            }
                            joins = null;
                            // If we have an interrupt and a fail, then the thread threw while
                            // running finalizers. This should always rethrow in a fresh stack.
                            if (interrupt && fail) setTimeout(function() {
                                throw util.fromLeft(fail);
                            }, 0);
                            else if (util.isLeft(step) && rethrow) setTimeout(function() {
                                // Guard on reathrow because a completely synchronous fiber can
                                // still have an observer which was added after-the-fact.
                                if (rethrow) throw util.fromLeft(step);
                            }, 0);
                            return;
                        case SUSPENDED:
                            status = CONTINUE;
                            break;
                        case PENDING:
                            return;
                    }
                }
            }
            function onComplete(join) {
                return function() {
                    if (status === COMPLETED) {
                        rethrow = rethrow && join.rethrow;
                        join.handler(step)();
                        return function() {
                        };
                    }
                    var jid = joinId++;
                    joins = joins || {
                    };
                    joins[jid] = join;
                    return function() {
                        if (joins !== null) delete joins[jid];
                    };
                };
            }
            function kill(error, cb) {
                return function() {
                    if (status === COMPLETED) {
                        cb(util.right(void 0))();
                        return function() {
                        };
                    }
                    var canceler = onComplete({
                        rethrow: false,
                        handler: function() {
                            return cb(util.right(void 0));
                        }
                    })();
                    switch(status){
                        case SUSPENDED:
                            interrupt = util.left(error);
                            status = COMPLETED;
                            step = interrupt;
                            run(runTick);
                            break;
                        case PENDING:
                            if (interrupt === null) interrupt = util.left(error);
                            if (bracketCount === 0) {
                                if (status === PENDING) attempts = new Aff1(CONS, new Aff1(FINALIZER, step(error)), attempts, interrupt);
                                status = RETURN;
                                step = null;
                                fail = null;
                                run(++runTick);
                            }
                            break;
                        default:
                            if (interrupt === null) interrupt = util.left(error);
                            if (bracketCount === 0) {
                                status = RETURN;
                                step = null;
                                fail = null;
                            }
                    }
                    return canceler;
                };
            }
            function join(cb) {
                return function() {
                    var canceler = onComplete({
                        rethrow: false,
                        handler: cb
                    })();
                    if (status === SUSPENDED) run(runTick);
                    return canceler;
                };
            }
            return {
                kill: kill,
                join: join,
                onComplete: onComplete,
                isSuspended: function() {
                    return status === SUSPENDED;
                },
                run: function() {
                    if (status === SUSPENDED) {
                        if (!Scheduler.isDraining()) Scheduler.enqueue(function() {
                            run(runTick);
                        });
                        else run(runTick);
                    }
                }
            };
        }
        function runPar(util, supervisor, par, cb) {
            // Table of all forked fibers.
            var fiberId = 0;
            var fibers = {
            };
            // Table of currently running cancelers, as a product of `Alt` behavior.
            var killId = 0;
            var kills = {
            };
            // Error used for early cancelation on Alt branches.
            var early = new Error("[ParAff] Early exit");
            // Error used to kill the entire tree.
            var interrupt = null;
            // The root pointer of the tree.
            var root = EMPTY;
            // Walks a tree, invoking all the cancelers. Returns the table of pending
            // cancellation fibers.
            function kill(error, par1, cb1) {
                var step = par1;
                var head = null;
                var tail = null;
                var count = 0;
                var kills1 = {
                };
                var tmp, kid;
                loop: while(true){
                    tmp = null;
                    switch(step.tag){
                        case FORKED:
                            if (step._3 === EMPTY) {
                                tmp = fibers[step._1];
                                kills1[count++] = tmp.kill(error, function(result) {
                                    return function() {
                                        count--;
                                        if (count === 0) cb1(result)();
                                    };
                                });
                            }
                            // Terminal case.
                            if (head === null) break loop;
                            // Go down the right side of the tree.
                            step = head._2;
                            if (tail === null) head = null;
                            else {
                                head = tail._1;
                                tail = tail._2;
                            }
                            break;
                        case MAP:
                            step = step._2;
                            break;
                        case APPLY:
                        case ALT:
                            if (head) tail = new Aff1(CONS, head, tail);
                            head = step;
                            step = step._1;
                            break;
                    }
                }
                if (count === 0) cb1(util.right(void 0))();
                else {
                    // Run the cancelation effects. We alias `count` because it's mutable.
                    kid = 0;
                    tmp = count;
                    for(; kid < tmp; kid++)kills1[kid] = kills1[kid]();
                }
                return kills1;
            }
            // When a fiber resolves, we need to bubble back up the tree with the
            // result, computing the applicative nodes.
            function join(result, head, tail) {
                var fail, step, lhs, rhs, tmp, kid;
                if (util.isLeft(result)) {
                    fail = result;
                    step = null;
                } else {
                    step = result;
                    fail = null;
                }
                loop: while(true){
                    lhs = null;
                    rhs = null;
                    tmp = null;
                    kid = null;
                    // We should never continue if the entire tree has been interrupted.
                    if (interrupt !== null) return;
                    // We've made it all the way to the root of the tree, which means
                    // the tree has fully evaluated.
                    if (head === null) {
                        cb(fail || step)();
                        return;
                    }
                    // The tree has already been computed, so we shouldn't try to do it
                    // again. This should never happen.
                    // TODO: Remove this?
                    if (head._3 !== EMPTY) return;
                    switch(head.tag){
                        case MAP:
                            if (fail === null) {
                                head._3 = util.right(head._1(util.fromRight(step)));
                                step = head._3;
                            } else head._3 = fail;
                            break;
                        case APPLY:
                            lhs = head._1._3;
                            rhs = head._2._3;
                            // If we have a failure we should kill the other side because we
                            // can't possible yield a result anymore.
                            if (fail) {
                                head._3 = fail;
                                tmp = true;
                                kid = killId++;
                                kills[kid] = kill(early, fail === lhs ? head._2 : head._1, function() {
                                    return function() {
                                        delete kills[kid];
                                        if (tmp) tmp = false;
                                        else if (tail === null) join(fail, null, null);
                                        else join(fail, tail._1, tail._2);
                                    };
                                });
                                if (tmp) {
                                    tmp = false;
                                    return;
                                }
                            } else if (lhs === EMPTY || rhs === EMPTY) // We can only proceed if both sides have resolved.
                            return;
                            else {
                                step = util.right(util.fromRight(lhs)(util.fromRight(rhs)));
                                head._3 = step;
                            }
                            break;
                        case ALT:
                            lhs = head._1._3;
                            rhs = head._2._3;
                            // We can only proceed if both have resolved or we have a success
                            if (lhs === EMPTY && util.isLeft(rhs) || rhs === EMPTY && util.isLeft(lhs)) return;
                            // If both sides resolve with an error, we should continue with the
                            // first error
                            if (lhs !== EMPTY && util.isLeft(lhs) && rhs !== EMPTY && util.isLeft(rhs)) {
                                fail = step === lhs ? rhs : lhs;
                                step = null;
                                head._3 = fail;
                            } else {
                                head._3 = step;
                                tmp = true;
                                kid = killId++;
                                // Once a side has resolved, we need to cancel the side that is still
                                // pending before we can continue.
                                kills[kid] = kill(early, step === lhs ? head._2 : head._1, function() {
                                    return function() {
                                        delete kills[kid];
                                        if (tmp) tmp = false;
                                        else if (tail === null) join(step, null, null);
                                        else join(step, tail._1, tail._2);
                                    };
                                });
                                if (tmp) {
                                    tmp = false;
                                    return;
                                }
                            }
                            break;
                    }
                    if (tail === null) head = null;
                    else {
                        head = tail._1;
                        tail = tail._2;
                    }
                }
            }
            function resolve(fiber) {
                return function(result) {
                    return function() {
                        delete fibers[fiber._1];
                        fiber._3 = result;
                        join(result, fiber._2._1, fiber._2._2);
                    };
                };
            }
            // Walks the applicative tree, substituting non-applicative nodes with
            // `FORKED` nodes. In this tree, all applicative nodes use the `_3` slot
            // as a mutable slot for memoization. In an unresolved state, the `_3`
            // slot is `EMPTY`. In the cases of `ALT` and `APPLY`, we always walk
            // the left side first, because both operations are left-associative. As
            // we `RETURN` from those branches, we then walk the right side.
            function run() {
                var status = CONTINUE;
                var step = par;
                var head = null;
                var tail = null;
                var tmp, fid;
                loop: while(true){
                    tmp = null;
                    fid = null;
                    switch(status){
                        case CONTINUE:
                            switch(step.tag){
                                case MAP:
                                    if (head) tail = new Aff1(CONS, head, tail);
                                    head = new Aff1(MAP, step._1, EMPTY, EMPTY);
                                    step = step._2;
                                    break;
                                case APPLY:
                                    if (head) tail = new Aff1(CONS, head, tail);
                                    head = new Aff1(APPLY, EMPTY, step._2, EMPTY);
                                    step = step._1;
                                    break;
                                case ALT:
                                    if (head) tail = new Aff1(CONS, head, tail);
                                    head = new Aff1(ALT, EMPTY, step._2, EMPTY);
                                    step = step._1;
                                    break;
                                default:
                                    // When we hit a leaf value, we suspend the stack in the `FORKED`.
                                    // When the fiber resolves, it can bubble back up the tree.
                                    fid = fiberId++;
                                    status = RETURN;
                                    tmp = step;
                                    step = new Aff1(FORKED, fid, new Aff1(CONS, head, tail), EMPTY);
                                    tmp = Fiber(util, supervisor, tmp);
                                    tmp.onComplete({
                                        rethrow: false,
                                        handler: resolve(step)
                                    })();
                                    fibers[fid] = tmp;
                                    if (supervisor) supervisor.register(tmp);
                            }
                            break;
                        case RETURN:
                            // Terminal case, we are back at the root.
                            if (head === null) break loop;
                            // If we are done with the right side, we need to continue down the
                            // left. Otherwise we should continue up the stack.
                            if (head._1 === EMPTY) {
                                head._1 = step;
                                status = CONTINUE;
                                step = head._2;
                                head._2 = EMPTY;
                            } else {
                                head._2 = step;
                                step = head;
                                if (tail === null) head = null;
                                else {
                                    head = tail._1;
                                    tail = tail._2;
                                }
                            }
                    }
                }
                // Keep a reference to the tree root so it can be cancelled.
                root = step;
                for(fid = 0; fid < fiberId; fid++)fibers[fid].run();
            }
            // Cancels the entire tree. If there are already subtrees being canceled,
            // we need to first cancel those joins. We will then add fresh joins for
            // all pending branches including those that were in the process of being
            // canceled.
            function cancel(error, cb1) {
                interrupt = util.left(error);
                var innerKills;
                for(var kid in kills)if (kills.hasOwnProperty(kid)) {
                    innerKills = kills[kid];
                    for(kid in innerKills)if (innerKills.hasOwnProperty(kid)) innerKills[kid]();
                }
                kills = null;
                var newKills = kill(error, root, cb1);
                return function(killError) {
                    return new Aff1(ASYNC, function(killCb) {
                        return function() {
                            for(var kid1 in newKills)if (newKills.hasOwnProperty(kid1)) newKills[kid1]();
                            return nonCanceler;
                        };
                    });
                };
            }
            run();
            return function(killError) {
                return new Aff1(ASYNC, function(killCb) {
                    return function() {
                        return cancel(killError, killCb);
                    };
                });
            };
        }
        function sequential(util, supervisor, par) {
            return new Aff1(ASYNC, function(cb) {
                return function() {
                    return runPar(util, supervisor, par, cb);
                };
            });
        }
        Aff1.EMPTY = EMPTY;
        Aff1.Pure = AffCtr(PURE);
        Aff1.Throw = AffCtr(THROW);
        Aff1.Catch = AffCtr(CATCH);
        Aff1.Sync = AffCtr(SYNC);
        Aff1.Async = AffCtr(ASYNC);
        Aff1.Bind = AffCtr(BIND);
        Aff1.Bracket = AffCtr(BRACKET);
        Aff1.Fork = AffCtr(FORK);
        Aff1.Seq = AffCtr(SEQ);
        Aff1.ParMap = AffCtr(MAP);
        Aff1.ParApply = AffCtr(APPLY);
        Aff1.ParAlt = AffCtr(ALT);
        Aff1.Fiber = Fiber;
        Aff1.Supervisor = Supervisor;
        Aff1.Scheduler = Scheduler;
        Aff1.nonCanceler = nonCanceler;
        return Aff1;
    }();
    exports._pure = Aff.Pure;
    exports._throwError = Aff.Throw;
    exports._catchError = function(aff) {
        return function(k) {
            return Aff.Catch(aff, k);
        };
    };
    exports._map = function(f) {
        return function(aff) {
            if (aff.tag === Aff.Pure.tag) return Aff.Pure(f(aff._1));
            else return Aff.Bind(aff, function(value) {
                return Aff.Pure(f(value));
            });
        };
    };
    exports._bind = function(aff) {
        return function(k) {
            return Aff.Bind(aff, k);
        };
    };
    exports._liftEffect = Aff.Sync;
    exports.makeAff = Aff.Async;
    exports._makeFiber = function(util, aff) {
        return function() {
            return Aff.Fiber(util, null, aff);
        };
    };
})(PS["Effect.Aff"] = PS["Effect.Aff"] || {
});
(function($PS) {
    $PS["Effect.Class"] = $PS["Effect.Class"] || {
    };
    var exports = $PS["Effect.Class"];
    var MonadEffect = function(Monad0, liftEffect) {
        this.Monad0 = Monad0;
        this.liftEffect = liftEffect;
    };
    var liftEffect = function(dict) {
        return dict.liftEffect;
    };
    exports["liftEffect"] = liftEffect;
    exports["MonadEffect"] = MonadEffect;
})(PS);
(function(exports) {
    // module Partial.Unsafe
    exports._unsafePartial = function(f) {
        return f();
    };
})(PS["Partial.Unsafe"] = PS["Partial.Unsafe"] || {
});
(function(exports) {
    // module Partial
    exports._crashWith = function(msg) {
        throw new Error(msg);
    };
})(PS["Partial"] = PS["Partial"] || {
});
(function($PS) {
    $PS["Partial"] = $PS["Partial"] || {
    };
    var exports = $PS["Partial"];
    var $foreign = $PS["Partial"];
    var crashWith = function(dictPartial) {
        return $foreign["_crashWith"];
    };
    exports["crashWith"] = crashWith;
})(PS);
(function($PS) {
    $PS["Partial.Unsafe"] = $PS["Partial.Unsafe"] || {
    };
    var exports = $PS["Partial.Unsafe"];
    var $foreign = $PS["Partial.Unsafe"];
    var Partial = $PS["Partial"];
    var unsafePartial = $foreign["_unsafePartial"];
    var unsafeCrashWith = function(msg) {
        return unsafePartial(function(dictPartial) {
            return Partial.crashWith()(msg);
        });
    };
    exports["unsafeCrashWith"] = unsafeCrashWith;
})(PS);
(function($PS) {
    $PS["Effect.Aff"] = $PS["Effect.Aff"] || {
    };
    var exports = $PS["Effect.Aff"];
    var $foreign = $PS["Effect.Aff"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Control_Bind = $PS["Control.Bind"];
    var Control_Monad = $PS["Control.Monad"];
    var Control_Monad_Error_Class = $PS["Control.Monad.Error.Class"];
    var Data_Either = $PS["Data.Either"];
    var Data_Function = $PS["Data.Function"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_Unit = $PS["Data.Unit"];
    var Effect_Class = $PS["Effect.Class"];
    var Partial_Unsafe = $PS["Partial.Unsafe"];
    var functorAff = new Data_Functor.Functor($foreign["_map"]);
    var ffiUtil = function() {
        var unsafeFromRight = function(v) {
            if (v instanceof Data_Either.Right) return v.value0;
            if (v instanceof Data_Either.Left) return Partial_Unsafe.unsafeCrashWith("unsafeFromRight: Left");
            throw new Error("Failed pattern match at Effect.Aff (line 404, column 21 - line 406, column 54): " + [
                v.constructor.name
            ]);
        };
        var unsafeFromLeft = function(v) {
            if (v instanceof Data_Either.Left) return v.value0;
            if (v instanceof Data_Either.Right) return Partial_Unsafe.unsafeCrashWith("unsafeFromLeft: Right");
            throw new Error("Failed pattern match at Effect.Aff (line 399, column 20 - line 401, column 54): " + [
                v.constructor.name
            ]);
        };
        var isLeft = function(v) {
            if (v instanceof Data_Either.Left) return true;
            if (v instanceof Data_Either.Right) return false;
            throw new Error("Failed pattern match at Effect.Aff (line 394, column 12 - line 396, column 20): " + [
                v.constructor.name
            ]);
        };
        return {
            isLeft: isLeft,
            fromLeft: unsafeFromLeft,
            fromRight: unsafeFromRight,
            left: Data_Either.Left.create,
            right: Data_Either.Right.create
        };
    }();
    var makeFiber = function(aff) {
        return $foreign["_makeFiber"](ffiUtil, aff);
    };
    var launchAff = function(aff) {
        return function __do() {
            var fiber = makeFiber(aff)();
            fiber.run();
            return fiber;
        };
    };
    var monadAff = new Control_Monad.Monad(function() {
        return applicativeAff;
    }, function() {
        return bindAff;
    });
    var bindAff = new Control_Bind.Bind(function() {
        return applyAff;
    }, $foreign["_bind"]);
    var applyAff = new Control_Apply.Apply(function() {
        return functorAff;
    }, Control_Monad.ap(monadAff));
    var applicativeAff = new Control_Applicative.Applicative(function() {
        return applyAff;
    }, $foreign["_pure"]);
    var monadEffectAff = new Effect_Class.MonadEffect(function() {
        return monadAff;
    }, $foreign["_liftEffect"]);
    var monadThrowAff = new Control_Monad_Error_Class.MonadThrow(function() {
        return monadAff;
    }, $foreign["_throwError"]);
    var monadErrorAff = new Control_Monad_Error_Class.MonadError(function() {
        return monadThrowAff;
    }, $foreign["_catchError"]);
    var nonCanceler = Data_Function["const"](Control_Applicative.pure(applicativeAff)(Data_Unit.unit));
    exports["launchAff"] = launchAff;
    exports["nonCanceler"] = nonCanceler;
    exports["functorAff"] = functorAff;
    exports["applicativeAff"] = applicativeAff;
    exports["bindAff"] = bindAff;
    exports["monadErrorAff"] = monadErrorAff;
    exports["monadEffectAff"] = monadEffectAff;
    exports["makeAff"] = $foreign.makeAff;
})(PS);
(function($PS) {
    $PS["Effect.Aff.Compat"] = $PS["Effect.Aff.Compat"] || {
    };
    var exports = $PS["Effect.Aff.Compat"];
    var Data_Either = $PS["Data.Either"];
    var Effect_Aff = $PS["Effect.Aff"];
    var fromEffectFnAff = function(v) {
        return Effect_Aff.makeAff(function(k) {
            return function __do() {
                var v1 = v(function($4) {
                    return k(Data_Either.Left.create($4))();
                }, function($5) {
                    return k(Data_Either.Right.create($5))();
                });
                return function(e) {
                    return Effect_Aff.makeAff(function(k2) {
                        return function __do1() {
                            v1(e, function($6) {
                                return k2(Data_Either.Left.create($6))();
                            }, function($7) {
                                return k2(Data_Either.Right.create($7))();
                            });
                            return Effect_Aff.nonCanceler;
                        };
                    });
                };
            };
        });
    };
    exports["fromEffectFnAff"] = fromEffectFnAff;
})(PS);
(function(exports) {
    exports.message = function(e) {
        return e.message;
    };
    exports.catchException = function(c) {
        return function(t) {
            return function() {
                try {
                    return t();
                } catch (e) {
                    if (e instanceof Error || Object.prototype.toString.call(e) === "[object Error]") return c(e)();
                    else return c(new Error(e.toString()))();
                }
            };
        };
    };
})(PS["Effect.Exception"] = PS["Effect.Exception"] || {
});
(function(exports) {
    exports.pureE = function(a) {
        return function() {
            return a;
        };
    };
    exports.bindE = function(a) {
        return function(f) {
            return function() {
                return f(a())();
            };
        };
    };
})(PS["Effect"] = PS["Effect"] || {
});
(function($PS) {
    $PS["Effect"] = $PS["Effect"] || {
    };
    var exports = $PS["Effect"];
    var $foreign = $PS["Effect"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Control_Bind = $PS["Control.Bind"];
    var Control_Monad = $PS["Control.Monad"];
    var Data_Functor = $PS["Data.Functor"];
    var monadEffect = new Control_Monad.Monad(function() {
        return applicativeEffect;
    }, function() {
        return bindEffect;
    });
    var bindEffect = new Control_Bind.Bind(function() {
        return applyEffect;
    }, $foreign.bindE);
    var applyEffect = new Control_Apply.Apply(function() {
        return functorEffect;
    }, Control_Monad.ap(monadEffect));
    var applicativeEffect = new Control_Applicative.Applicative(function() {
        return applyEffect;
    }, $foreign.pureE);
    var functorEffect = new Data_Functor.Functor(Control_Applicative.liftA1(applicativeEffect));
    exports["functorEffect"] = functorEffect;
    exports["applicativeEffect"] = applicativeEffect;
})(PS);
(function($PS) {
    $PS["Effect.Exception"] = $PS["Effect.Exception"] || {
    };
    var exports = $PS["Effect.Exception"];
    var $foreign = $PS["Effect.Exception"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Data_Either = $PS["Data.Either"];
    var Data_Functor = $PS["Data.Functor"];
    var Effect = $PS["Effect"];
    var $$try = function(action) {
        return $foreign.catchException(function() {
            var $0 = Control_Applicative.pure(Effect.applicativeEffect);
            return function($1) {
                return $0(Data_Either.Left.create($1));
            };
        }())(Data_Functor.map(Effect.functorEffect)(Data_Either.Right.create)(action));
    };
    exports["try"] = $$try;
    exports["message"] = $foreign.message;
})(PS);
(function(exports) {
    exports.typeOf = function(value) {
        return typeof value;
    };
    exports.tagOf = function(value) {
        return Object.prototype.toString.call(value).slice(8, -1);
    };
    exports.isNull = function(value) {
        return value === null;
    };
    exports.isUndefined = function(value) {
        return value === undefined;
    };
    exports.isArray = Array.isArray || function(value) {
        return Object.prototype.toString.call(value) === "[object Array]";
    };
})(PS["Foreign"] = PS["Foreign"] || {
});
(function($PS) {
    $PS["Data.Boolean"] = $PS["Data.Boolean"] || {
    };
    var exports = $PS["Data.Boolean"];
    var otherwise = true;
    exports["otherwise"] = otherwise;
})(PS);
(function($PS) {
    $PS["Foreign"] = $PS["Foreign"] || {
    };
    var exports = $PS["Foreign"];
    var $foreign = $PS["Foreign"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Monad_Error_Class = $PS["Control.Monad.Error.Class"];
    var Control_Monad_Except_Trans = $PS["Control.Monad.Except.Trans"];
    var Data_Boolean = $PS["Data.Boolean"];
    var Data_List_NonEmpty = $PS["Data.List.NonEmpty"];
    var Data_Show = $PS["Data.Show"];
    var Unsafe_Coerce = $PS["Unsafe.Coerce"];
    var ForeignError = function() {
        function ForeignError1(value0) {
            this.value0 = value0;
        }
        ForeignError1.create = function(value0) {
            return new ForeignError1(value0);
        };
        return ForeignError1;
    }();
    var TypeMismatch = function() {
        function TypeMismatch1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        TypeMismatch1.create = function(value0) {
            return function(value1) {
                return new TypeMismatch1(value0, value1);
            };
        };
        return TypeMismatch1;
    }();
    var ErrorAtIndex = function() {
        function ErrorAtIndex1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        ErrorAtIndex1.create = function(value0) {
            return function(value1) {
                return new ErrorAtIndex1(value0, value1);
            };
        };
        return ErrorAtIndex1;
    }();
    var ErrorAtProperty = function() {
        function ErrorAtProperty1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        ErrorAtProperty1.create = function(value0) {
            return function(value1) {
                return new ErrorAtProperty1(value0, value1);
            };
        };
        return ErrorAtProperty1;
    }();
    var unsafeToForeign = Unsafe_Coerce.unsafeCoerce;
    var unsafeFromForeign = Unsafe_Coerce.unsafeCoerce;
    var showForeignError = new Data_Show.Show(function(v) {
        if (v instanceof ForeignError) return "(ForeignError " + (Data_Show.show(Data_Show.showString)(v.value0) + ")");
        if (v instanceof ErrorAtIndex) return "(ErrorAtIndex " + (Data_Show.show(Data_Show.showInt)(v.value0) + (" " + (Data_Show.show(showForeignError)(v.value1) + ")")));
        if (v instanceof ErrorAtProperty) return "(ErrorAtProperty " + (Data_Show.show(Data_Show.showString)(v.value0) + (" " + (Data_Show.show(showForeignError)(v.value1) + ")")));
        if (v instanceof TypeMismatch) return "(TypeMismatch " + (Data_Show.show(Data_Show.showString)(v.value0) + (" " + (Data_Show.show(Data_Show.showString)(v.value1) + ")")));
        throw new Error("Failed pattern match at Foreign (line 64, column 1 - line 68, column 89): " + [
            v.constructor.name
        ]);
    });
    var renderForeignError = function(v) {
        if (v instanceof ForeignError) return v.value0;
        if (v instanceof ErrorAtIndex) return "Error at array index " + (Data_Show.show(Data_Show.showInt)(v.value0) + (": " + renderForeignError(v.value1)));
        if (v instanceof ErrorAtProperty) return "Error at property " + (Data_Show.show(Data_Show.showString)(v.value0) + (": " + renderForeignError(v.value1)));
        if (v instanceof TypeMismatch) return "Type mismatch: expected " + (v.value0 + (", found " + v.value1));
        throw new Error("Failed pattern match at Foreign (line 73, column 1 - line 73, column 45): " + [
            v.constructor.name
        ]);
    };
    var fail = function(dictMonad) {
        var $118 = Control_Monad_Error_Class.throwError(Control_Monad_Except_Trans.monadThrowExceptT(dictMonad));
        return function($119) {
            return $118(Data_List_NonEmpty.singleton($119));
        };
    };
    var readArray = function(dictMonad) {
        return function(value) {
            if ($foreign.isArray(value)) return Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(dictMonad))(unsafeFromForeign(value));
            if (Data_Boolean.otherwise) return fail(dictMonad)(new TypeMismatch("array", $foreign.tagOf(value)));
            throw new Error("Failed pattern match at Foreign (line 151, column 1 - line 151, column 66): " + [
                value.constructor.name
            ]);
        };
    };
    var unsafeReadTagged = function(dictMonad) {
        return function(tag) {
            return function(value) {
                if ($foreign.tagOf(value) === tag) return Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(dictMonad))(unsafeFromForeign(value));
                if (Data_Boolean.otherwise) return fail(dictMonad)(new TypeMismatch(tag, $foreign.tagOf(value)));
                throw new Error("Failed pattern match at Foreign (line 110, column 1 - line 110, column 71): " + [
                    tag.constructor.name,
                    value.constructor.name
                ]);
            };
        };
    };
    var readString = function(dictMonad) {
        return unsafeReadTagged(dictMonad)("String");
    };
    exports["ForeignError"] = ForeignError;
    exports["TypeMismatch"] = TypeMismatch;
    exports["ErrorAtIndex"] = ErrorAtIndex;
    exports["ErrorAtProperty"] = ErrorAtProperty;
    exports["renderForeignError"] = renderForeignError;
    exports["unsafeToForeign"] = unsafeToForeign;
    exports["unsafeReadTagged"] = unsafeReadTagged;
    exports["readString"] = readString;
    exports["readArray"] = readArray;
    exports["fail"] = fail;
    exports["showForeignError"] = showForeignError;
    exports["typeOf"] = $foreign.typeOf;
    exports["isNull"] = $foreign.isNull;
    exports["isUndefined"] = $foreign.isUndefined;
})(PS);
(function($PS) {
    $PS["Affjax"] = $PS["Affjax"] || {
    };
    var exports = $PS["Affjax"];
    var $foreign = $PS["Affjax"];
    var Affjax_RequestBody = $PS["Affjax.RequestBody"];
    var Affjax_RequestHeader = $PS["Affjax.RequestHeader"];
    var Affjax_ResponseFormat = $PS["Affjax.ResponseFormat"];
    var Affjax_ResponseHeader = $PS["Affjax.ResponseHeader"];
    var Control_Alt = $PS["Control.Alt"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Bind = $PS["Control.Bind"];
    var Control_Monad_Error_Class = $PS["Control.Monad.Error.Class"];
    var Control_Monad_Except = $PS["Control.Monad.Except"];
    var Control_Monad_Except_Trans = $PS["Control.Monad.Except.Trans"];
    var Data_Argonaut_Core = $PS["Data.Argonaut.Core"];
    var Data_Argonaut_Parser = $PS["Data.Argonaut.Parser"];
    var Data_Array = $PS["Data.Array"];
    var Data_Either = $PS["Data.Either"];
    var Data_Eq = $PS["Data.Eq"];
    var Data_Foldable = $PS["Data.Foldable"];
    var Data_FormURLEncoded = $PS["Data.FormURLEncoded"];
    var Data_Function = $PS["Data.Function"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_HTTP_Method = $PS["Data.HTTP.Method"];
    var Data_HeytingAlgebra = $PS["Data.HeytingAlgebra"];
    var Data_Identity = $PS["Data.Identity"];
    var Data_List_NonEmpty = $PS["Data.List.NonEmpty"];
    var Data_List_Types = $PS["Data.List.Types"];
    var Data_Maybe = $PS["Data.Maybe"];
    var Data_Nullable = $PS["Data.Nullable"];
    var Data_Unit = $PS["Data.Unit"];
    var Effect_Aff = $PS["Effect.Aff"];
    var Effect_Aff_Compat = $PS["Effect.Aff.Compat"];
    var Effect_Exception = $PS["Effect.Exception"];
    var Foreign = $PS["Foreign"];
    var RequestContentError = function() {
        function RequestContentError1(value0) {
            this.value0 = value0;
        }
        RequestContentError1.create = function(value0) {
            return new RequestContentError1(value0);
        };
        return RequestContentError1;
    }();
    var ResponseBodyError = function() {
        function ResponseBodyError1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        ResponseBodyError1.create = function(value0) {
            return function(value1) {
                return new ResponseBodyError1(value0, value1);
            };
        };
        return ResponseBodyError1;
    }();
    var TimeoutError = function() {
        function TimeoutError1() {
        }
        TimeoutError1.value = new TimeoutError1();
        return TimeoutError1;
    }();
    var RequestFailedError = function() {
        function RequestFailedError1() {
        }
        RequestFailedError1.value = new RequestFailedError1();
        return RequestFailedError1;
    }();
    var XHROtherError = function() {
        function XHROtherError1(value0) {
            this.value0 = value0;
        }
        XHROtherError1.create = function(value0) {
            return new XHROtherError1(value0);
        };
        return XHROtherError1;
    }();
    var request = function(req) {
        var parseJSON = function(v) {
            if (v === "") return Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(Data_Identity.monadIdentity))(Data_Argonaut_Core.jsonEmptyObject);
            return Data_Either.either(function() {
                var $51 = Foreign.fail(Data_Identity.monadIdentity);
                return function($52) {
                    return $51(Foreign.ForeignError.create($52));
                };
            }())(Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(Data_Identity.monadIdentity)))(Data_Argonaut_Parser.jsonParser(v));
        };
        var fromResponse = function() {
            if (req.responseFormat instanceof Affjax_ResponseFormat["ArrayBuffer"]) return Foreign.unsafeReadTagged(Data_Identity.monadIdentity)("ArrayBuffer");
            if (req.responseFormat instanceof Affjax_ResponseFormat.Blob) return Foreign.unsafeReadTagged(Data_Identity.monadIdentity)("Blob");
            if (req.responseFormat instanceof Affjax_ResponseFormat.Document) return function(x) {
                return Control_Alt.alt(Control_Monad_Except_Trans.altExceptT(Data_List_Types.semigroupNonEmptyList)(Data_Identity.monadIdentity))(Control_Alt.alt(Control_Monad_Except_Trans.altExceptT(Data_List_Types.semigroupNonEmptyList)(Data_Identity.monadIdentity))(Foreign.unsafeReadTagged(Data_Identity.monadIdentity)("Document")(x))(Foreign.unsafeReadTagged(Data_Identity.monadIdentity)("XMLDocument")(x)))(Foreign.unsafeReadTagged(Data_Identity.monadIdentity)("HTMLDocument")(x));
            };
            if (req.responseFormat instanceof Affjax_ResponseFormat.Json) return Control_Bind.composeKleisliFlipped(Control_Monad_Except_Trans.bindExceptT(Data_Identity.monadIdentity))(function($53) {
                return req.responseFormat.value0(parseJSON($53));
            })(Foreign.unsafeReadTagged(Data_Identity.monadIdentity)("String"));
            if (req.responseFormat instanceof Affjax_ResponseFormat["String"]) return Foreign.unsafeReadTagged(Data_Identity.monadIdentity)("String");
            if (req.responseFormat instanceof Affjax_ResponseFormat.Ignore) return Data_Function["const"](req.responseFormat.value0(Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(Data_Identity.monadIdentity))(Data_Unit.unit)));
            throw new Error("Failed pattern match at Affjax (line 257, column 18 - line 265, column 57): " + [
                req.responseFormat.constructor.name
            ]);
        }();
        var extractContent = function(v) {
            if (v instanceof Affjax_RequestBody.ArrayView) return Data_Either.Right.create(v.value0(Foreign.unsafeToForeign));
            if (v instanceof Affjax_RequestBody.Blob) return Data_Either.Right.create(Foreign.unsafeToForeign(v.value0));
            if (v instanceof Affjax_RequestBody.Document) return Data_Either.Right.create(Foreign.unsafeToForeign(v.value0));
            if (v instanceof Affjax_RequestBody["String"]) return Data_Either.Right.create(Foreign.unsafeToForeign(v.value0));
            if (v instanceof Affjax_RequestBody.FormData) return Data_Either.Right.create(Foreign.unsafeToForeign(v.value0));
            if (v instanceof Affjax_RequestBody.FormURLEncoded) return Data_Either.note("Body contains values that cannot be encoded as application/x-www-form-urlencoded")(Data_Functor.map(Data_Maybe.functorMaybe)(Foreign.unsafeToForeign)(Data_FormURLEncoded.encode(v.value0)));
            if (v instanceof Affjax_RequestBody.Json) return Data_Either.Right.create(Foreign.unsafeToForeign(Data_Argonaut_Core.stringify(v.value0)));
            throw new Error("Failed pattern match at Affjax (line 217, column 20 - line 232, column 69): " + [
                v.constructor.name
            ]);
        };
        var addHeader = function(mh) {
            return function(hs) {
                if (mh instanceof Data_Maybe.Just && !Data_Foldable.any(Data_Foldable.foldableArray)(Data_HeytingAlgebra.heytingAlgebraBoolean)(Data_Function.on(Data_Eq.eq(Data_Eq.eqString))(Affjax_RequestHeader.name)(mh.value0))(hs)) return Data_Array.snoc(hs)(mh.value0);
                return hs;
            };
        };
        var headers = function(reqContent) {
            return addHeader(Data_Functor.map(Data_Maybe.functorMaybe)(Affjax_RequestHeader.ContentType.create)(Control_Bind.bindFlipped(Data_Maybe.bindMaybe)(Affjax_RequestBody.toMediaType)(reqContent)))(addHeader(Data_Functor.map(Data_Maybe.functorMaybe)(Affjax_RequestHeader.Accept.create)(Affjax_ResponseFormat.toMediaType(req.responseFormat)))(req.headers));
        };
        var ajaxRequest = function(v) {
            return {
                method: Data_HTTP_Method.print(req.method),
                url: req.url,
                headers: Data_Functor.map(Data_Functor.functorArray)(function(h) {
                    return {
                        field: Affjax_RequestHeader.name(h),
                        value: Affjax_RequestHeader.value(h)
                    };
                })(headers(req.content)),
                content: v,
                responseType: Affjax_ResponseFormat.toResponseType(req.responseFormat),
                username: Data_Nullable.toNullable(req.username),
                password: Data_Nullable.toNullable(req.password),
                withCredentials: req.withCredentials,
                timeout: Data_Maybe.fromMaybe(0)(Data_Functor.map(Data_Maybe.functorMaybe)(function(v1) {
                    return v1;
                })(req.timeout))
            };
        };
        var send = function(content) {
            return Data_Functor.mapFlipped(Effect_Aff.functorAff)(Control_Monad_Error_Class["try"](Effect_Aff.monadErrorAff)(Effect_Aff_Compat.fromEffectFnAff($foreign["_ajax"]("AffjaxTimeoutErrorMessageIdent", "AffjaxRequestFailedMessageIdent", Affjax_ResponseHeader.ResponseHeader.create, ajaxRequest(content)))))(function(v) {
                if (v instanceof Data_Either.Right) {
                    var v1 = Control_Monad_Except.runExcept(fromResponse(v.value0.body));
                    if (v1 instanceof Data_Either.Left) return new Data_Either.Left(new ResponseBodyError(Data_List_NonEmpty.head(v1.value0), v.value0));
                    if (v1 instanceof Data_Either.Right) return new Data_Either.Right({
                        body: v1.value0,
                        headers: v.value0.headers,
                        status: v.value0.status,
                        statusText: v.value0.statusText
                    });
                    throw new Error("Failed pattern match at Affjax (line 193, column 9 - line 195, column 52): " + [
                        v1.constructor.name
                    ]);
                }
                if (v instanceof Data_Either.Left) {
                    var message = Effect_Exception.message(v.value0);
                    return Data_Either.Left.create(function() {
                        var $38 = message === "AffjaxTimeoutErrorMessageIdent";
                        if ($38) return TimeoutError.value;
                        var $39 = message === "AffjaxRequestFailedMessageIdent";
                        if ($39) return RequestFailedError.value;
                        return new XHROtherError(v.value0);
                    }());
                }
                throw new Error("Failed pattern match at Affjax (line 191, column 137 - line 201, column 33): " + [
                    v.constructor.name
                ]);
            });
        };
        if (req.content instanceof Data_Maybe.Nothing) return send(Data_Nullable.toNullable(Data_Maybe.Nothing.value));
        if (req.content instanceof Data_Maybe.Just) {
            var v = extractContent(req.content.value0);
            if (v instanceof Data_Either.Right) return send(Data_Nullable.toNullable(new Data_Maybe.Just(v.value0)));
            if (v instanceof Data_Either.Left) return Control_Applicative.pure(Effect_Aff.applicativeAff)(new Data_Either.Left(new RequestContentError(v.value0)));
            throw new Error("Failed pattern match at Affjax (line 183, column 7 - line 187, column 48): " + [
                v.constructor.name
            ]);
        }
        throw new Error("Failed pattern match at Affjax (line 179, column 3 - line 187, column 48): " + [
            req.content.constructor.name
        ]);
    };
    var printError = function(v) {
        if (v instanceof RequestContentError) return "There was a problem with the request content: " + v.value0;
        if (v instanceof ResponseBodyError) return "There was a problem with the response body: " + Foreign.renderForeignError(v.value0);
        if (v instanceof TimeoutError) return "There was a problem making the request: timeout";
        if (v instanceof RequestFailedError) return "There was a problem making the request: request failed";
        if (v instanceof XHROtherError) return "There was a problem making the request: " + Effect_Exception.message(v.value0);
        throw new Error("Failed pattern match at Affjax (line 97, column 14 - line 107, column 66): " + [
            v.constructor.name
        ]);
    };
    var defaultRequest = {
        method: new Data_Either.Left(Data_HTTP_Method.GET.value),
        url: "/",
        headers: [],
        content: Data_Maybe.Nothing.value,
        username: Data_Maybe.Nothing.value,
        password: Data_Maybe.Nothing.value,
        withCredentials: false,
        responseFormat: Affjax_ResponseFormat.ignore,
        timeout: Data_Maybe.Nothing.value
    };
    exports["defaultRequest"] = defaultRequest;
    exports["printError"] = printError;
    exports["request"] = request;
})(PS);
(function($PS) {
    $PS["Data.Bifunctor"] = $PS["Data.Bifunctor"] || {
    };
    var exports = $PS["Data.Bifunctor"];
    var Control_Category = $PS["Control.Category"];
    var Data_Either = $PS["Data.Either"];
    var Bifunctor = function(bimap) {
        this.bimap = bimap;
    };
    var bimap = function(dict) {
        return dict.bimap;
    };
    var lmap = function(dictBifunctor) {
        return function(f) {
            return bimap(dictBifunctor)(f)(Control_Category.identity(Control_Category.categoryFn));
        };
    };
    var bifunctorEither = new Bifunctor(function(v) {
        return function(v1) {
            return function(v2) {
                if (v2 instanceof Data_Either.Left) return new Data_Either.Left(v(v2.value0));
                if (v2 instanceof Data_Either.Right) return new Data_Either.Right(v1(v2.value0));
                throw new Error("Failed pattern match at Data.Bifunctor (line 32, column 1 - line 34, column 36): " + [
                    v.constructor.name,
                    v1.constructor.name,
                    v2.constructor.name
                ]);
            };
        };
    });
    exports["lmap"] = lmap;
    exports["bifunctorEither"] = bifunctorEither;
})(PS);
(function(exports) {
    exports.mapWithIndexArray = function(f) {
        return function(xs) {
            var l = xs.length;
            var result = Array(l);
            for(var i = 0; i < l; i++)result[i] = f(i)(xs[i]);
            return result;
        };
    };
})(PS["Data.FunctorWithIndex"] = PS["Data.FunctorWithIndex"] || {
});
(function($PS) {
    $PS["Data.FunctorWithIndex"] = $PS["Data.FunctorWithIndex"] || {
    };
    var exports = $PS["Data.FunctorWithIndex"];
    var $foreign = $PS["Data.FunctorWithIndex"];
    var Data_Functor = $PS["Data.Functor"];
    var FunctorWithIndex = function(Functor0, mapWithIndex) {
        this.Functor0 = Functor0;
        this.mapWithIndex = mapWithIndex;
    };
    var mapWithIndex = function(dict) {
        return dict.mapWithIndex;
    };
    var functorWithIndexArray = new FunctorWithIndex(function() {
        return Data_Functor.functorArray;
    }, $foreign.mapWithIndexArray);
    exports["mapWithIndex"] = mapWithIndex;
    exports["functorWithIndexArray"] = functorWithIndexArray;
})(PS);
(function($PS) {
    $PS["Data.Tuple"] = $PS["Data.Tuple"] || {
    };
    var exports = $PS["Data.Tuple"];
    var Tuple = function() {
        function Tuple1(value0, value1) {
            this.value0 = value0;
            this.value1 = value1;
        }
        Tuple1.create = function(value0) {
            return function(value1) {
                return new Tuple1(value0, value1);
            };
        };
        return Tuple1;
    }();
    exports["Tuple"] = Tuple;
})(PS);
(function($PS) {
    $PS["Data.FoldableWithIndex"] = $PS["Data.FoldableWithIndex"] || {
    };
    var exports = $PS["Data.FoldableWithIndex"];
    var Data_Foldable = $PS["Data.Foldable"];
    var Data_FunctorWithIndex = $PS["Data.FunctorWithIndex"];
    var Data_Monoid = $PS["Data.Monoid"];
    var Data_Semigroup = $PS["Data.Semigroup"];
    var Data_Tuple = $PS["Data.Tuple"];
    var FoldableWithIndex = function(Foldable0, foldMapWithIndex, foldlWithIndex, foldrWithIndex) {
        this.Foldable0 = Foldable0;
        this.foldMapWithIndex = foldMapWithIndex;
        this.foldlWithIndex = foldlWithIndex;
        this.foldrWithIndex = foldrWithIndex;
    };
    var foldrWithIndex = function(dict) {
        return dict.foldrWithIndex;
    };
    var foldMapWithIndexDefaultR = function(dictFoldableWithIndex) {
        return function(dictMonoid) {
            return function(f) {
                return foldrWithIndex(dictFoldableWithIndex)(function(i) {
                    return function(x) {
                        return function(acc) {
                            return Data_Semigroup.append(dictMonoid.Semigroup0())(f(i)(x))(acc);
                        };
                    };
                })(Data_Monoid.mempty(dictMonoid));
            };
        };
    };
    var foldableWithIndexArray = new FoldableWithIndex(function() {
        return Data_Foldable.foldableArray;
    }, function(dictMonoid) {
        return foldMapWithIndexDefaultR(foldableWithIndexArray)(dictMonoid);
    }, function(f) {
        return function(z) {
            var $164 = Data_Foldable.foldl(Data_Foldable.foldableArray)(function(y) {
                return function(v) {
                    return f(v.value0)(y)(v.value1);
                };
            })(z);
            var $165 = Data_FunctorWithIndex.mapWithIndex(Data_FunctorWithIndex.functorWithIndexArray)(Data_Tuple.Tuple.create);
            return function($166) {
                return $164($165($166));
            };
        };
    }, function(f) {
        return function(z) {
            var $167 = Data_Foldable.foldr(Data_Foldable.foldableArray)(function(v) {
                return function(y) {
                    return f(v.value0)(v.value1)(y);
                };
            })(z);
            var $168 = Data_FunctorWithIndex.mapWithIndex(Data_FunctorWithIndex.functorWithIndexArray)(Data_Tuple.Tuple.create);
            return function($169) {
                return $167($168($169));
            };
        };
    });
    exports["foldableWithIndexArray"] = foldableWithIndexArray;
})(PS);
(function($PS) {
    $PS["Data.TraversableWithIndex"] = $PS["Data.TraversableWithIndex"] || {
    };
    var exports = $PS["Data.TraversableWithIndex"];
    var Data_FoldableWithIndex = $PS["Data.FoldableWithIndex"];
    var Data_FunctorWithIndex = $PS["Data.FunctorWithIndex"];
    var Data_Traversable = $PS["Data.Traversable"];
    var TraversableWithIndex = function(FoldableWithIndex1, FunctorWithIndex0, Traversable2, traverseWithIndex) {
        this.FoldableWithIndex1 = FoldableWithIndex1;
        this.FunctorWithIndex0 = FunctorWithIndex0;
        this.Traversable2 = Traversable2;
        this.traverseWithIndex = traverseWithIndex;
    };
    var traverseWithIndexDefault = function(dictTraversableWithIndex) {
        return function(dictApplicative) {
            return function(f) {
                var $63 = Data_Traversable.sequence(dictTraversableWithIndex.Traversable2())(dictApplicative);
                var $64 = Data_FunctorWithIndex.mapWithIndex(dictTraversableWithIndex.FunctorWithIndex0())(f);
                return function($65) {
                    return $63($64($65));
                };
            };
        };
    };
    var traverseWithIndex = function(dict) {
        return dict.traverseWithIndex;
    };
    var traversableWithIndexArray = new TraversableWithIndex(function() {
        return Data_FoldableWithIndex.foldableWithIndexArray;
    }, function() {
        return Data_FunctorWithIndex.functorWithIndexArray;
    }, function() {
        return Data_Traversable.traversableArray;
    }, function(dictApplicative) {
        return traverseWithIndexDefault(traversableWithIndexArray)(dictApplicative);
    });
    exports["traverseWithIndex"] = traverseWithIndex;
    exports["traversableWithIndexArray"] = traversableWithIndexArray;
})(PS);
(function(exports) {
    exports.log = function(s) {
        return function() {
            console.log(s);
        };
    };
})(PS["Effect.Console"] = PS["Effect.Console"] || {
});
(function($PS) {
    $PS["Effect.Console"] = $PS["Effect.Console"] || {
    };
    var exports = $PS["Effect.Console"];
    var $foreign = $PS["Effect.Console"];
    exports["log"] = $foreign.log;
})(PS);
(function($PS) {
    $PS["Effect.Class.Console"] = $PS["Effect.Class.Console"] || {
    };
    var exports = $PS["Effect.Class.Console"];
    var Effect_Class = $PS["Effect.Class"];
    var Effect_Console = $PS["Effect.Console"];
    var log = function(dictMonadEffect) {
        var $30 = Effect_Class.liftEffect(dictMonadEffect);
        return function($31) {
            return $30(Effect_Console.log($31));
        };
    };
    exports["log"] = log;
})(PS);
(function(exports) {
    exports.runEffectFn1 = function runEffectFn1(fn) {
        return function(a) {
            return function() {
                return fn(a);
            };
        };
    };
})(PS["Effect.Uncurried"] = PS["Effect.Uncurried"] || {
});
(function($PS) {
    $PS["Effect.Uncurried"] = $PS["Effect.Uncurried"] || {
    };
    var exports = $PS["Effect.Uncurried"];
    var $foreign = $PS["Effect.Uncurried"];
    exports["runEffectFn1"] = $foreign.runEffectFn1;
})(PS);
(function(exports) {
    exports.unsafePerformEffect = function(f) {
        return f();
    };
})(PS["Effect.Unsafe"] = PS["Effect.Unsafe"] || {
});
(function($PS) {
    $PS["Effect.Unsafe"] = $PS["Effect.Unsafe"] || {
    };
    var exports = $PS["Effect.Unsafe"];
    var $foreign = $PS["Effect.Unsafe"];
    exports["unsafePerformEffect"] = $foreign.unsafePerformEffect;
})(PS);
(function(exports) {
    exports.unsafeReadPropImpl = function(f, s, key, value) {
        return value == null ? f : s(value[key]);
    };
})(PS["Foreign.Index"] = PS["Foreign.Index"] || {
});
(function($PS) {
    $PS["Foreign.Index"] = $PS["Foreign.Index"] || {
    };
    var exports = $PS["Foreign.Index"];
    var $foreign = $PS["Foreign.Index"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Monad_Except_Trans = $PS["Control.Monad.Except.Trans"];
    var Foreign = $PS["Foreign"];
    var unsafeReadProp = function(dictMonad) {
        return function(k) {
            return function(value) {
                return $foreign.unsafeReadPropImpl(Foreign.fail(dictMonad)(new Foreign.TypeMismatch("object", Foreign.typeOf(value))), Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(dictMonad)), k, value);
            };
        };
    };
    var readProp = function(dictMonad) {
        return unsafeReadProp(dictMonad);
    };
    exports["readProp"] = readProp;
})(PS);
(function(exports) {
    exports._parseJSON = JSON.parse;
})(PS["Simple.JSON"] = PS["Simple.JSON"] || {
});
(function(exports) {
    exports.copyRecord = function(rec) {
        var copy = {
        };
        for(var key in rec)if (({
        }).hasOwnProperty.call(rec, key)) copy[key] = rec[key];
        return copy;
    };
    exports.unsafeInsert = function(l) {
        return function(a) {
            return function(rec) {
                rec[l] = a;
                return rec;
            };
        };
    };
})(PS["Record.Builder"] = PS["Record.Builder"] || {
});
(function($PS) {
    $PS["Record.Builder"] = $PS["Record.Builder"] || {
    };
    var exports = $PS["Record.Builder"];
    var $foreign = $PS["Record.Builder"];
    var Control_Category = $PS["Control.Category"];
    var Control_Semigroupoid = $PS["Control.Semigroupoid"];
    var Data_Symbol = $PS["Data.Symbol"];
    var semigroupoidBuilder = Control_Semigroupoid.semigroupoidFn;
    var insert = function(dictCons) {
        return function(dictLacks) {
            return function(dictIsSymbol) {
                return function(l) {
                    return function(a) {
                        return function(r1) {
                            return $foreign.unsafeInsert(Data_Symbol.reflectSymbol(dictIsSymbol)(l))(a)(r1);
                        };
                    };
                };
            };
        };
    };
    var categoryBuilder = Control_Category.categoryFn;
    var build = function(v) {
        return function(r1) {
            return v($foreign.copyRecord(r1));
        };
    };
    exports["build"] = build;
    exports["insert"] = insert;
    exports["semigroupoidBuilder"] = semigroupoidBuilder;
    exports["categoryBuilder"] = categoryBuilder;
})(PS);
(function($PS) {
    $PS["Simple.JSON"] = $PS["Simple.JSON"] || {
    };
    var exports = $PS["Simple.JSON"];
    var $foreign = $PS["Simple.JSON"];
    var Control_Applicative = $PS["Control.Applicative"];
    var Control_Apply = $PS["Control.Apply"];
    var Control_Bind = $PS["Control.Bind"];
    var Control_Category = $PS["Control.Category"];
    var Control_Monad_Except = $PS["Control.Monad.Except"];
    var Control_Monad_Except_Trans = $PS["Control.Monad.Except.Trans"];
    var Control_Semigroupoid = $PS["Control.Semigroupoid"];
    var Data_Bifunctor = $PS["Data.Bifunctor"];
    var Data_Either = $PS["Data.Either"];
    var Data_Function = $PS["Data.Function"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_Identity = $PS["Data.Identity"];
    var Data_List_Types = $PS["Data.List.Types"];
    var Data_Maybe = $PS["Data.Maybe"];
    var Data_Semigroup = $PS["Data.Semigroup"];
    var Data_Symbol = $PS["Data.Symbol"];
    var Data_TraversableWithIndex = $PS["Data.TraversableWithIndex"];
    var Effect_Exception = $PS["Effect.Exception"];
    var Effect_Uncurried = $PS["Effect.Uncurried"];
    var Effect_Unsafe = $PS["Effect.Unsafe"];
    var Foreign = $PS["Foreign"];
    var Foreign_Index = $PS["Foreign.Index"];
    var Record_Builder = $PS["Record.Builder"];
    var Type_Proxy = $PS["Type.Proxy"];
    var ReadForeignFields = function(getFields) {
        this.getFields = getFields;
    };
    var ReadForeign = function(readImpl) {
        this.readImpl = readImpl;
    };
    var readString = new ReadForeign(Foreign.readString(Data_Identity.monadIdentity));
    var readImpl = function(dict) {
        return dict.readImpl;
    };
    var readMaybe = function(dictReadForeign) {
        return new ReadForeign(function() {
            var readNullOrUndefined = function(v) {
                return function(value) {
                    if (Foreign.isNull(value) || Foreign.isUndefined(value)) return Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(Data_Identity.monadIdentity))(Data_Maybe.Nothing.value);
                    return Data_Functor.map(Control_Monad_Except_Trans.functorExceptT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(v(value));
                };
            };
            return readNullOrUndefined(readImpl(dictReadForeign));
        }());
    };
    var readFieldsNil = new ReadForeignFields(function(v) {
        return function(v1) {
            return Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(Data_Identity.monadIdentity))(Control_Category.identity(Record_Builder.categoryBuilder));
        };
    });
    var readArray = function(dictReadForeign) {
        return new ReadForeign(function() {
            var readAtIdx = function(i) {
                return function(f) {
                    return Control_Monad_Except.withExcept(Data_Functor.map(Data_List_Types.functorNonEmptyList)(Foreign.ErrorAtIndex.create(i)))(readImpl(dictReadForeign)(f));
                };
            };
            return Control_Bind.composeKleisliFlipped(Control_Monad_Except_Trans.bindExceptT(Data_Identity.monadIdentity))(Data_TraversableWithIndex.traverseWithIndex(Data_TraversableWithIndex.traversableWithIndexArray)(Control_Monad_Except_Trans.applicativeExceptT(Data_Identity.monadIdentity))(readAtIdx))(Foreign.readArray(Data_Identity.monadIdentity));
        }());
    };
    var parseJSON = function() {
        var $102 = Data_Bifunctor.lmap(Data_Bifunctor.bifunctorEither)(function() {
            var $105 = Control_Applicative.pure(Data_List_Types.applicativeNonEmptyList);
            return function($106) {
                return $105(Foreign.ForeignError.create(Effect_Exception.message($106)));
            };
        }());
        var $103 = Effect_Uncurried.runEffectFn1($foreign["_parseJSON"]);
        return function($104) {
            return Control_Monad_Except_Trans.ExceptT(Data_Identity.Identity($102(Effect_Unsafe.unsafePerformEffect(Effect_Exception["try"]($103($104))))));
        };
    }();
    var readJSON = function(dictReadForeign) {
        var $107 = Control_Bind.composeKleisliFlipped(Control_Monad_Except_Trans.bindExceptT(Data_Identity.monadIdentity))(readImpl(dictReadForeign))(parseJSON);
        return function($108) {
            return Control_Monad_Except.runExcept($107($108));
        };
    };
    var getFields = function(dict) {
        return dict.getFields;
    };
    var readRecord = function(dictRowToList) {
        return function(dictReadForeignFields) {
            return new ReadForeign(function(o) {
                return Data_Functor.map(Control_Monad_Except_Trans.functorExceptT(Data_Identity.functorIdentity))(Data_Function.flip(Record_Builder.build)({
                }))(getFields(dictReadForeignFields)(Type_Proxy["Proxy"].value)(o));
            });
        };
    };
    var applyEither = function(dictSemigroup) {
        return function(v) {
            return function(v1) {
                if (v instanceof Data_Either.Left && v1 instanceof Data_Either.Right) return new Data_Either.Left(v.value0);
                if (v instanceof Data_Either.Left && v1 instanceof Data_Either.Left) return new Data_Either.Left(Data_Semigroup.append(dictSemigroup)(v.value0)(v1.value0));
                if (v instanceof Data_Either.Right && v1 instanceof Data_Either.Left) return new Data_Either.Left(v1.value0);
                if (v instanceof Data_Either.Right && v1 instanceof Data_Either.Right) return new Data_Either.Right(v.value0(v1.value0));
                throw new Error("Failed pattern match at Simple.JSON (line 241, column 1 - line 241, column 90): " + [
                    v.constructor.name,
                    v1.constructor.name
                ]);
            };
        };
    };
    var exceptTApply = function(dictSemigroup) {
        return function(dictApplicative) {
            return function(fun) {
                return function(a) {
                    return Control_Monad_Except_Trans.ExceptT(Control_Apply.apply(dictApplicative.Apply0())(Data_Functor.map(dictApplicative.Apply0().Functor0())(applyEither(dictSemigroup))(Control_Monad_Except_Trans.runExceptT(fun)))(Control_Monad_Except_Trans.runExceptT(a)));
                };
            };
        };
    };
    var readFieldsCons = function(dictIsSymbol) {
        return function(dictReadForeign) {
            return function(dictReadForeignFields) {
                return function(dictLacks) {
                    return function(dictCons) {
                        return new ReadForeignFields(function(v) {
                            return function(obj) {
                                var rest = getFields(dictReadForeignFields)(Type_Proxy["Proxy"].value)(obj);
                                var name = Data_Symbol.reflectSymbol(dictIsSymbol)(Data_Symbol.SProxy.value);
                                var withExcept$prime = Control_Monad_Except.withExcept(Data_Functor.map(Data_List_Types.functorNonEmptyList)(Foreign.ErrorAtProperty.create(name)));
                                var first = Control_Bind.bind(Control_Monad_Except_Trans.bindExceptT(Data_Identity.monadIdentity))(withExcept$prime(Control_Bind.bindFlipped(Control_Monad_Except_Trans.bindExceptT(Data_Identity.monadIdentity))(readImpl(dictReadForeign))(Foreign_Index.readProp(Data_Identity.monadIdentity)(name)(obj))))(function(value) {
                                    return Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(Data_Identity.monadIdentity))(Record_Builder.insert()()(dictIsSymbol)(Data_Symbol.SProxy.value)(value));
                                });
                                return exceptTApply(Data_List_Types.semigroupNonEmptyList)(Data_Identity.applicativeIdentity)(Data_Functor.map(Control_Monad_Except_Trans.functorExceptT(Data_Identity.functorIdentity))(Control_Semigroupoid.compose(Record_Builder.semigroupoidBuilder))(first))(rest);
                            };
                        });
                    };
                };
            };
        };
    };
    exports["readJSON"] = readJSON;
    exports["readString"] = readString;
    exports["readArray"] = readArray;
    exports["readMaybe"] = readMaybe;
    exports["readRecord"] = readRecord;
    exports["readFieldsCons"] = readFieldsCons;
    exports["readFieldsNil"] = readFieldsNil;
})(PS);
(function($PS) {
    $PS["Main"] = $PS["Main"] || {
    };
    var exports = $PS["Main"];
    var Affjax = $PS["Affjax"];
    var Affjax_ResponseFormat = $PS["Affjax.ResponseFormat"];
    var Control_Bind = $PS["Control.Bind"];
    var Data_Either = $PS["Data.Either"];
    var Data_Functor = $PS["Data.Functor"];
    var Data_HTTP_Method = $PS["Data.HTTP.Method"];
    var Data_List_Types = $PS["Data.List.Types"];
    var Data_Maybe = $PS["Data.Maybe"];
    var Data_Show = $PS["Data.Show"];
    var Data_Symbol = $PS["Data.Symbol"];
    var Effect = $PS["Effect"];
    var Effect_Aff = $PS["Effect.Aff"];
    var Effect_Class_Console = $PS["Effect.Class.Console"];
    var Foreign = $PS["Foreign"];
    var Simple_JSON = $PS["Simple.JSON"];
    var main = Data_Functor["void"](Effect.functorEffect)(Effect_Aff.launchAff(Control_Bind.bind(Effect_Aff.bindAff)(Affjax.request({
        method: new Data_Either.Left(Data_HTTP_Method.GET.value),
        url: "http://localhost:5501/static/knowledge-phylomemy.json",
        headers: Affjax.defaultRequest.headers,
        content: Affjax.defaultRequest.content,
        username: Affjax.defaultRequest.username,
        password: Affjax.defaultRequest.password,
        withCredentials: Affjax.defaultRequest.withCredentials,
        responseFormat: Affjax_ResponseFormat.string,
        timeout: Affjax.defaultRequest.timeout
    }))(function(result) {
        if (result instanceof Data_Either.Left) return Effect_Class_Console.log(Effect_Aff.monadEffectAff)("Phylo failed to load error : " + Affjax.printError(result.value0));
        if (result instanceof Data_Either.Right) {
            var v = Simple_JSON.readJSON(Simple_JSON.readRecord()(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "name";
            }))(Simple_JSON.readString)(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "objects";
            }))(Simple_JSON.readArray(Simple_JSON.readRecord()(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "name";
            }))(Simple_JSON.readString)(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "nodeType";
            }))(Simple_JSON.readMaybe(Simple_JSON.readString))(Simple_JSON.readFieldsNil)()())()())))(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "phyloBranches";
            }))(Simple_JSON.readString)(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "phyloDocs";
            }))(Simple_JSON.readString)(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "phyloFoundations";
            }))(Simple_JSON.readString)(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "phyloGroups";
            }))(Simple_JSON.readString)(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "phyloPeriods";
            }))(Simple_JSON.readString)(Simple_JSON.readFieldsCons(new Data_Symbol.IsSymbol(function() {
                return "phyloTerms";
            }))(Simple_JSON.readString)(Simple_JSON.readFieldsNil)()())()())()())()())()())()())()())()()))(result.value0.body);
            if (v instanceof Data_Either.Left) return Effect_Class_Console.log(Effect_Aff.monadEffectAff)("Fail with error: " + Data_Show.show(Data_List_Types.showNonEmptyList(Foreign.showForeignError))(v.value0));
            if (v instanceof Data_Either.Right) return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(Effect_Class_Console.log(Effect_Aff.monadEffectAff)("name of phylo is : " + Data_Show.show(Data_Show.showString)(v.value0.name)))(function() {
                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(Effect_Class_Console.log(Effect_Aff.monadEffectAff)("number of docs is : " + Data_Show.show(Data_Show.showString)(v.value0.phyloDocs)))(function() {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(Effect_Class_Console.log(Effect_Aff.monadEffectAff)("number of foundations is : " + Data_Show.show(Data_Show.showString)(v.value0.phyloFoundations)))(function() {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(Effect_Class_Console.log(Effect_Aff.monadEffectAff)("number of periods is : " + Data_Show.show(Data_Show.showString)(v.value0.phyloPeriods)))(function() {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(Effect_Class_Console.log(Effect_Aff.monadEffectAff)("number of terms is : " + Data_Show.show(Data_Show.showString)(v.value0.phyloTerms)))(function() {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(Effect_Class_Console.log(Effect_Aff.monadEffectAff)("number of groups is : " + Data_Show.show(Data_Show.showString)(v.value0.phyloGroups)))(function() {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(Effect_Class_Console.log(Effect_Aff.monadEffectAff)("number of branches is : " + Data_Show.show(Data_Show.showString)(v.value0.phyloBranches)))(function() {
                                        return Effect_Class_Console.log(Effect_Aff.monadEffectAff)("objects are : " + Data_Show.show(Data_Show.showArray(Data_Show.showRecord()(Data_Show.showRecordFieldsCons(new Data_Symbol.IsSymbol(function() {
                                            return "name";
                                        }))(Data_Show.showRecordFieldsCons(new Data_Symbol.IsSymbol(function() {
                                            return "nodeType";
                                        }))(Data_Show.showRecordFieldsNil)(Data_Maybe.showMaybe(Data_Show.showString)))(Data_Show.showString))))(v.value0.objects));
                                    });
                                });
                            });
                        });
                    });
                });
            });
            throw new Error("Failed pattern match at Main (line 41, column 7 - line 51, column 51): " + [
                v.constructor.name
            ]);
        }
        throw new Error("Failed pattern match at Main (line 38, column 3 - line 51, column 51): " + [
            result.constructor.name
        ]);
    })));
    exports["main"] = main;
})(PS);
PS["Main"].main();

//# sourceMappingURL=index.c71f97c6.js.map
