module App where
  
import Prelude

import Data.Maybe (Maybe(..), fromMaybe)
import Data.Nullable (toMaybe)
import Data.Tuple.Nested ( (/\) )
import Effect (Effect)
import FFI.Simple ((...), delay, args2)
import DOM.Simple as DOM
import DOM.Simple.Document (document)
import DOM.Simple (Element)
import DOM.Simple.Console (log, log2)
import Reactix as R
import Reactix.DOM.HTML as H


-- type Phylo = (className :: String, phylo :: String)
-- 
-- 
-- phylo :: Record Phylo -> R.Element
-- phylo props = R.createElement phyloCpt props []
-- 
-- helloPhylo :: R.Element
-- helloPhylo = H.div { className : "phylo", phylo: "Hello"}
-- 
-- phyloCpt :: R.Component Phylo
-- phyloCpt = R.hooksComponent "phylo" cpt where
--   cpt {className, phylo} _children = 
--     pure $ H.div { className } [H.text phylo]

helloCounter :: R.Element
helloCounter = counter { initialCount: 0 }

type Counter = ( initialCount :: Int )

counter :: Record Counter -> R.Element
counter props = R.createElement counterCpt props []

counterCpt :: R.Component Counter
counterCpt = R.hooksComponent "counter" cpt where
  cpt { initialCount } _children = do
    (count /\ setCount) <- R.useState' initialCount
    pure $ H.div {}
      [ H.button { on: { click: \_event -> setCount (_ + 1) } }
        [ H.text "Don't click me" ]
      , H.text ("Clicked " <> show count <> " times!") ]

